unit CompanyEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ContactEdit, Db, StdCtrls, ExtCtrls, Grids, DBGrids,
  Mask, DBCtrls, ComCtrls, Menus, ImgList, ActnList, Buttons,
  ovIObjects, ovComponents, ovVirtualDataSet, ovDataSet;

type
  TCompanyEditForm = class(TContactEditForm)
    Actions: TActionList;
    ActionImages: TImageList;
    EmployeeButtonPanel: TPanel;
    EmployeeDeleteAction: TAction;
    EmployeeDeleteButton: TBitBtn;
    EmployeeDeleteItem: TMenuItem;
    EmployeeEditAction: TAction;
    EmployeeEditButton: TBitBtn;
    EmployeeEditItem: TMenuItem;
    EmployeeGrid: TDBGrid;
    EmployeeGridMenu: TPopupMenu;
    EmployeeGridPanel: TPanel;
    EmployeeLookupButton: TBitBtn;
    EmployeeLookupAction: TAction;
    EmployeeLookupItem: TMenuItem;
    EmployeeNewAction: TAction;
    EmployeeNewButton: TBitBtn;
    EmployeeNewItem: TMenuItem;
    EmployeeRemoveAction: TAction;
    EmployeeRemoveButton: TBitBtn;
    EmployeeRemoveItem: TMenuItem;
    EmployeeSheet: TTabSheet;
    EmployeeExposer: TovExposer;
    EmployeeSource: TDataSource;
    EmployeeEMail: TStringField;
    EmployeePhone: TStringField;
    EmployeeExposerDSDesigner: TStringField;
    procedure ActionsUpdate(Action: TBasicAction; var Handled: Boolean);
    procedure EmployeeNewActionExecute(Sender: TObject);
    procedure EmployeeEditActionExecute(Sender: TObject);
    procedure EmployeeDeleteActionExecute(Sender: TObject);
    procedure EmployeeLookupActionExecute(Sender: TObject);
    procedure EmployeeRemoveActionExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OkButtonClick(Sender: TObject);
    procedure EmployeeExposerCalcFields(DataSet: TDataSet);
  private
  protected
  public
  end;

implementation

uses BasicEdit, Utility, PersonBrowse, Model;

{$R *.DFM}

{ TCompanyEditForm }

procedure TCompanyEditForm.FormShow(Sender: TObject);
begin
  inherited;
  PageControl.ActivePageIndex := 0;
end;

procedure TCompanyEditForm.ActionsUpdate(Action: TBasicAction;
  var Handled: Boolean);
begin
  EmployeeEditAction.Enabled := Not EmployeeExposer.IsEmpty;
  EmployeeDeleteAction.Enabled := EmployeeEditAction.Enabled;
  EmployeeRemoveAction.Enabled := EmployeeEditAction.Enabled;
end;

procedure TCompanyEditForm.EmployeeDeleteActionExecute(Sender: TObject);
begin
  if Confirm(Format(' "%s"    ?', [EmployeeExposer.CurrentObject[''].AsString]))
    then EmployeeExposer.DeleteCurrentObject;
end;

procedure TCompanyEditForm.EmployeeRemoveActionExecute(Sender: TObject);
begin
  if Confirm(Format(' "%s"   ?', [EmployeeExposer.CurrentObject[''].AsString]))
    then begin
      EmployBy(EmployeeExposer.CurrentObject, nil);
      EmployeeExposer.Refresh;
    end
end;

procedure TCompanyEditForm.EmployeeEditActionExecute(Sender: TObject);
begin
  with EmployeeExposer do
    if EditObject(CurrentObject) then Refresh;
end;

procedure TCompanyEditForm.EmployeeLookupActionExecute(Sender: TObject);
begin
  with TPersonBrowseForm.Create(nil) do
  try
    LookupMode := True;
    Selected := EmployeeExposer.CurrentObject;
    if Execute and Assigned(Selected) then
    begin
      EmployBy(Selected, Subject);
      EmployeeExposer.Refresh;
   end
  finally
    Free;
  end;
end;

procedure TCompanyEditForm.EmployeeNewActionExecute(Sender: TObject);
var
  Employee: IovObject;
begin
  Employee := CreateObject('');
  if EditObject(Employee) then
  begin
    if Not Assigned(Employee[' '].AsObject) then begin
      EmployBy(Employee, Subject);
      EmployeeExposer.Refresh;
    end
  end else
    Employee.Delete
end;

procedure TCompanyEditForm.OkButtonClick(Sender: TObject);
begin
  inherited;
  ContactExposer.CheckBrowseMode;
  PhoneExposer.CheckBrowseMode;
end;

procedure TCompanyEditForm.EmployeeExposerCalcFields(DataSet: TDataSet);
begin
  inherited;
  if EmployeeExposer.CurrentObject <> nil then
    with EmployeeExposer.CurrentObject do begin
      if Properties[''].Count > 0 then
        EmployeePhone.Value := Properties[''].Objects[0][''].AsString;
      if Properties[' '].Count > 0 then
        EmployeeEMail.Value := Properties[' '].Objects[0][''].AsString;
    end
end;

initialization
  TCompanyEditForm.RegisterClass('');
end.
