unit ContactFilterEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ContactEdit, Db, StdCtrls, Grids, DBGrids, Mask,
  DBCtrls, ExtCtrls, ComCtrls, ovComponents, ovIObjects, ovDataSet,
  ovVirtualDataSet;

type
  TContactFilterEditForm = class(TContactEditForm)
    InfoPanel: TPanel;
    Info1Label: TLabel;
    Button1: TButton;
    procedure OkButtonClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    function IsEmpty: Boolean;
  protected
    function GetIsValid: Boolean; override;
    procedure SetSubject(const Value: IovObject); override;
  public
  end;

implementation

{$R *.DFM}

{ TContactFilterEditForm }

function TContactFilterEditForm.GetIsValid: Boolean;
begin
  Result := Not IsEmpty;
end;

function TContactFilterEditForm.IsEmpty: Boolean;
begin
  Result :=
    (NameEdit.Text = '') and
    (StreetEdit.Text = '') and
    (CityEdit.Text = '') and
    (ZipEdit.Text = '') and
    (StateEdit.Text = '') and
    (CountryEdit.Text = '') and
    (CategoryEdit.Text = '');
end;

procedure TContactFilterEditForm.OkButtonClick(Sender: TObject);
begin
  inherited;
  ContactExposer.CheckBrowseMode
end;

procedure TContactFilterEditForm.SetSubject(const Value: IovObject);
begin
  inherited;
  if Not ContactExposer.FindObject(Value.ObjectId) then
    raise Exception.Create('  ')
end;

procedure TContactFilterEditForm.Button1Click(Sender: TObject);
begin
  inherited;
  ContactExposer.Edit;
  ContactExposer.ClearFields;
end;

initialization
  TContactFilterEditForm.RegisterClass('');
end.
