unit DemoData;

interface

uses
  Classes, ovTypes, ovIObjects;

procedure CreateCategories;
procedure CreateCountries;
function CreateRandomCompany: IovObject;
function CreateRandomPerson(Company: IovObject): IovObject;

implementation

uses
  Utility, RandomData, SysUtils, Windows, Dialogs, Model, ovComponents;

procedure CreateCategories;
const
  CategoryNames: array[0..5] of string = (
    ' ',
    '',
    '',
    '',
    '',
    ''
  );
var
  I: Integer;
begin 
  for I := Low(CategoryNames) to High(CategoryNames) do
    with CreateObject('') do
    begin
      Properties[''].AsString := CategoryNames[I];
    end
end;

procedure CreateCountries;
const
  CountryNames: array[0..29] of string = (
    'AR:Argentina',
    'AT;Austria',
    'AU;Australia',
    'BE;Belgium',
    'BR;Brazil',
    'CA;Canada',
    'CH;Switzerland',
    'DE;Germany',
    'DK;Denmark',
    'EE;Estonia',
    'ES;Spain',
    'FR;France',
    'GR;Greece',
    'HK;Hong Kong',
    'IT;Italy',
    'MX;Mexico',
    'MY;Malaysia',
    'NL;Netherlands',
    'NO;Norway',
    'NZ;New Zealand',
    'PL;Poland',
    'PT;Portugal',
    'RU;Russia',
    'SE;Sweden',
    'SG;Singapore',
    'TW;Taiwan',
    'UA;Ukraine',
    'UK;United Kingdom',
    'US;United States',
    'ZA;South Africa'
  );
var
  I: Integer;
  S: string;
begin
  for I := Low(CountryNames) to High(CountryNames) do
    with CreateObject('') do
    begin
      S := CountryNames[I];
      Properties[''].AsString := System.Copy(S, 4, Length(S));
      Properties[''].AsString := System.Copy(S, 1, 2);
    end
end;

procedure CreateRandomAddress(Contact: IovObject);
var
  AObjectId: TOID;
begin
  ObjectSpace.BeginUpdate;
  try
    with Contact[''].AsObject do
    begin
      Properties[''].AsString := RandomCity;
      Properties[''].AsString := RandomStreet;
      Properties[''].AsString := RandomNumber(6);
      ObjectSpace.Classes[''].Objects.Find('[] = ''RU''', AObjectId);
      if ObjectId > 0 then Properties[''].AsObjectId := AObjectId;
    end
  finally
    ObjectSpace.EndUpdate;
  end;
end;

procedure CreateRandomPhones(Contact: IovObject; Names: array of string);
var
  I: Integer;
begin
  ObjectSpace.BeginUpdate;
  try
    for I := Low(Names) to High(Names) do
      if Random(3) > 0 then
      with Contact[''].Add do
      begin
        Properties[''].AsString := Names[I];
        Properties[''].AsString := RandomNumber(10);
      end
  finally
    ObjectSpace.EndUpdate;
  end;
end;

procedure CreateRandomEmails(Person: IovObject; Domains: array of string);
var
  I: Integer;
begin
  for I := Low(Domains) to High(Domains) do
    if Random(3) > 0 then
      Person[' '].Add[''].AsString :=
        RandomEmail(Person[''].AsString, Domains[I]);
end;

function CreateRandomCompany: IovObject;
begin
  Result := CreateObject('');
  Result[''].AsString := RandomCompanyName;
  CreateRandomAddress(Result);
  CreateRandomPhones(Result, ['Business', 'Fax', 'Mobile']);
end;

function CreateRandomPerson(Company: IovObject): IovObject;
var
  CompanyName: string;
begin
  Result := CreateObject('');
  ObjectSpace.BeginUpdate;
  try
    Result[''].AsString := RandomFullName(TGender(Random(2)));
    Result[' '].AsDateTime := Date - (20 * 365 + Random(365 * 50)); // 20 - 70 years old
    if Assigned(Company) then
    begin
      EmployBy(Result, Company);
      CompanyName := PartStr(Company[''].AsString, 1, ' ');
    end else
      CompanyName := LowerCase(RandomName);
  finally
    ObjectSpace.EndUpdate;
  end;
  CreateRandomAddress(Result);
  CreateRandomPhones(Result, ['Home', 'Mobile']);
  CreateRandomEmails(Result, [CompanyName, 'hotmail']);
end;

end.
