unit Model;

interface

uses
  SysUtils, Classes, Forms, ovComponents,
  ovIObjects, DB, ovModelStorage, ovModel, ovDBConnections, ovModelEvents;

type
  TdmModel = class(TDataModule)
    ovModel: TovModel;
    ovModelStorage: TovModelStorage;
    ovDatabaseConnection: TovDatabaseConnections;
    ovModelEvents: TovModelEvents;
    procedure DataModuleCreate(Sender: TObject);
    procedure EmployeeDeleteObject(Sender: TovModelEvents;
      AModelObject: TModelObject; AObjectId: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

function CreateObject(ClassName: String): IovObject;
procedure EmployBy(Person, Company: IovObject);
var
  dmModel: TdmModel;

implementation

uses
  Dialogs, ovTypes;

{$R *.dfm}

function CreateObject(ClassName: String): IovObject;
begin
  Result := ObjectSpace.Classes[ClassName].CreateObject;
end;

procedure EmployBy(Person, Company: IovObject);
begin
  ObjectSpace.StartTransaction;
  try
    if Person[' '].AsObject <> nil then
      Person[' '].AsObject[''].Remove(Person);

    Person[' '].AsObject := Company;

    if Company <> nil then
      Company[''].Add(Person);

    ObjectSpace.CommitTransaction;
  except
    ObjectSpace.RollbackTransaction;
  end;
end;

{ TdmModel }

procedure TdmModel.DataModuleCreate(Sender: TObject);
begin
  ovDatabaseConnection.ConnectionFileName := ChangeFileExt(Application.ExeName, '.ovc');
end;

procedure TdmModel.EmployeeDeleteObject(Sender: TovModelEvents;
  AModelObject: TModelObject; AObjectId: Integer);
var
  Employee: IovObject;
  Company: IovObject;
begin
  Employee := Sender.GetObject(AModelObject, AObjectId);
  Company := Employee[' '].AsObject;
  if Assigned(Company) then Company[''].Remove(Employee);
end;

end.
