{
  .

     (AddressExposer, AddressSource) 
 - AV         BDE.
}
unit PersonEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ContactEdit, Db, StdCtrls, ExtCtrls, Grids, DBGrids,
  Mask, DBCtrls, ComCtrls, Buttons, ToolWin, ImgList, ovComponents,
  ovIObjects, ovVirtualDataSet, ovDataSet;

type
  TPersonEditForm = class(TContactEditForm)
    BirthDateEdit: TDBEdit;
    BirthDateLabel: TLabel;
    EmployerLabel: TLabel;
    EmailsGrid: TDBGrid;
    EmailsLabel: TLabel;
    EmployerToolBar: TToolBar;
    EmployerEditButton: TToolButton;
    EmployerLookupButton: TToolButton;
    EmployerClearButton: TToolButton;
    EmployerToolImages: TImageList;
    PictureImage: TDBImage;
    PictureButton: TButton;
    Label1: TLabel;
    Bevel1: TBevel;
    EmployerEdit: TDBEdit;
    EMailExposer: TovExposer;
    EMailSource: TDataSource;
    AddressExposer: TovExposer;
    AddressSource: TDataSource;
    procedure EmployerClearButtonClick(Sender: TObject);
    procedure EmployerEditButtonClick(Sender: TObject);
    procedure EmployerLookupButtonClick(Sender: TObject);
    procedure PictureButtonClick(Sender: TObject);
    procedure OkButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
  private
  protected
    procedure UpdateActions; override;
  public
  end;

implementation

uses BasicEdit, CompanyBrowse, ExtDlgs, ovTypes, Model;

{$R *.DFM}

{ TPersonEditForm }

procedure TPersonEditForm.UpdateActions;
begin
  inherited;
  EmployerClearButton.Enabled := EmployerEdit.Text <> '';
end;

procedure TPersonEditForm.EmployerClearButtonClick(Sender: TObject);
begin
  EmployBy(Subject, nil);
  EmployerEdit.Text := '';
end;

procedure TPersonEditForm.EmployerEditButtonClick(Sender: TObject);
var
  Employer: IovObject;
begin
  Employer := Subject[' '].AsObject;
  if not Assigned(Employer) then
  begin
    Employer := CreateObject('');
    if Not EditObject(Employer) then Employer.Delete
    else begin
      EmployBy(Subject, Employer);
      ContactExposer.Refresh;
    end;
  end else
    if EditObject(Employer) then begin
      ContactExposer.Refresh;
    end
end;

procedure TPersonEditForm.EmployerLookupButtonClick(Sender: TObject);
begin
  with TCompanyBrowseForm.Create(nil) do
  try
    LookupMode := True;
    Selected := Subject[' '].AsObject;
    if Execute then
    begin
      EmployBy(Subject, Selected);
      ContactExposer.Refresh;
    end;
  finally
    Free;
  end;
end;

procedure TPersonEditForm.PictureButtonClick(Sender: TObject);
var
  Picture: TPicture;
begin
  with TOpenPictureDialog.Create(nil) do
  try
    if Execute then
    begin
      ContactExposer.Edit;
      Picture := TPicture.Create;
      try
        Picture.LoadFromFile(FileName);
        PictureImage.Picture.Assign(Picture);
      finally
        Picture.Free;
      end;
      ContactExposer.Post;
    end;
  finally
    Free;
  end;
end;

procedure TPersonEditForm.OkButtonClick(Sender: TObject);
begin
  inherited;
  ContactExposer.CheckBrowseMode;
  AddressExposer.CheckBrowseMode;
  PhoneExposer.CheckBrowseMode;
  EMailExposer.CheckBrowseMode;
end;

procedure TPersonEditForm.CancelButtonClick(Sender: TObject);
begin
  inherited;
  ContactExposer.Cancel;
end;

initialization
  TPersonEditForm.RegisterClass('');
end.
