unit QueryView;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  BasicView, Db, Grids, DBGrids, StdCtrls, ExtCtrls,
  ActnList, Menus, Buttons, ovComponents, ComCtrls, ovDataSet,
  ovVirtualDataSet;

type
  TQueryViewForm = class(TBasicViewForm)
    Actions: TActionList;
    CommandEdit: TMemo;
    CommandLabel: TLabel;
    CommandPanel: TPanel;
    ExampleComboBox: TComboBox;
    ExampleLabel: TLabel;
    ExecuteAction: TAction;
    ExecuteButton: TButton;
    ResultPanel: TPanel;
    Splitter: TSplitter;
    PageControl: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    ResultGrid: TDBGrid;
    mmSQL: TMemo;
    Query: TovQuery;
    DataSource: TDataSource;
    procedure ExecuteActionExecute(Sender: TObject);
    procedure ExampleComboBoxClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  protected
    procedure LoadExamples;
    procedure UpdateActions; override;
  public
    procedure Disconnect; override;
  end;

implementation

uses ovQueryManager, ovUtils, Model;

{$R *.DFM}

const
  Examples: array[0..11, 0..1] of string = (
    (' ',
    'SELECT [.*] FROM []'),
    (' ',
    'SELECT [.] FROM []'),
    (' ,   - ',
    'SELECT [.],[. .] '#13'FROM [] JOIN INNER [. ]'),
    (' ,  ',
    'SELECT [. .] '#13'FROM [] JOIN INNER [. ]'),
    (' ,     ',
    'SELECT [.] , Count([..]) FROM []'#13 +
    'GROUP BY [.] ORDER BY [.]'),
    (' ,  ',
    'SELECT [.] FROM []'#13+
    'WHERE [..] = '''''#13+
    'ORDER BY [.]'),
    ('  -',
    'SELECT [..] FROM []'#13+
    'WHERE [..] = '''''#13+
    'ORDER BY [..]'),
    (' ',
    'SELECT [.*] FROM [] WHERE [..] = '''''),
    ('    ',
    'SELECT [.], [..*] FROM []'#13+
    'WHERE [..] = '''' ORDER BY [.]'),
    ('       ',
    'SELECT DISTINCT [A..] FROM [] A'#13+
    'JOIN RIGHT OUTER [A.] WHERE [A.] is null ORDER BY [A..]'),
    (',   ',
    'SELECT [.], [..]'#13+
    'FROM [] WHERE [.] LIKE ''%Corp%'' ORDER BY [..] DESC'),
    ('    ,    ',
    'SELECT [.],[..],[. ..]'#13+
    'FROM []'#13+
    'WHERE [..] = [. ..]')
    (*  DBISAM
    'SELECT [.],[..],[. ..]'#13+
    'FROM [] GROUP BY [.]'#13+
    'HAVING [..] = [. ..]')
    *)
  );

procedure TQueryViewForm.FormCreate(Sender: TObject);
begin
  LoadExamples;
end;

procedure TQueryViewForm.LoadExamples;
var
  I: Integer;
begin
  with ExampleComboBox.Items do
  begin
    BeginUpdate;
    try
      for I := Low(Examples) to High(Examples) do
        Add(Examples[I, 0]);
    finally
      EndUpdate;
    end;
  end;
end;

procedure TQueryViewForm.Disconnect;
begin
  Query.Close;
  inherited;
end;

procedure TQueryViewForm.ExampleComboBoxClick(Sender: TObject);
begin
  with ExampleComboBox do
    if ItemIndex <> -1 then
      CommandEdit.Lines.Text := Examples[ItemIndex, 1];
end;

procedure TQueryViewForm.ExecuteActionExecute(Sender: TObject);
var
  I: Integer;
begin
  with Query do
  begin
    Close;
    Query.Text := CommandEdit.Text;
    try
      Open;
    finally
      mmSQL.Text := LastSQL;
      mmSQL.Lines.Insert(0, 'SQL :');
    end;
  end;

  mmSQL.Lines.Add('');
  mmSQL.Lines.Add('');
  mmSQL.Lines.Add(' :');
  with Query do
  for I := 0 to ObjectCount - 1 do
    mmSQL.Lines.Add(Format(' %s (%s)', [ObjectNames[I], ObjectClasses[I]]));
end;

procedure TQueryViewForm.UpdateActions;
begin
  inherited;
  ExecuteAction.Enabled := CommandEdit.Text <> '';
  if Query.Active then
    ShowStatus(Format(' : %d', [Query.RecordCount]));
end;

end.
