unit Utility;

interface

procedure BeginBusy;
procedure EndBusy;
function Confirm(const Text: string): Boolean;
function PartStr(Str: string; Index: Integer; Delimiter: Char): string;

implementation

uses
  Forms, Dialogs, Controls;

var
  BusySaveCursor: TCursor;
  BusyCount: Integer;

procedure BeginBusy;
begin
  if BusyCount = 0 then
  begin
    BusySaveCursor := Screen.Cursor;
    Screen.Cursor := crHourglass;
  end;
  Inc(BusyCount);
end;

procedure EndBusy;
begin
  if BusyCount > 0 then
  begin
    Dec(BusyCount);
    if BusyCount = 0 then
      Screen.Cursor := BusySaveCursor;
  end;
end;

function Confirm(const Text: string): Boolean;
begin
  Result := MessageDlg(Text, mtConfirmation, [mbYes, mbNo], 0) = mrYes;
end;

function PartStr(Str: string; Index: Integer; Delimiter: Char): string;
var
  P: Integer;
begin
  while (Index > 1) and (Str <> '') do
  begin
    P := Pos(Delimiter, Str);
    if P = 0 then
      Str := ''
    else
      Delete(Str, 1, P);
    Dec(Index);
  end;
  P := Pos(Delimiter, Str);
  if P <> 0 then
    Delete(Str, P, Length(Str) - P + 1);
  Result := Str;
end;

end.
