unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, ovVirtualDataSet, ovDataSet, Grids, DBGrids, DBCtrls,
  ExtCtrls, ovIObjects, ComCtrls, StdCtrls, Mask, DBActns, ActnList, ExtDlgs,
  JPEG;

type
  TFieldDemoForm = class(TForm)
    PersonSource: TDataSource;
    PersonExposer: TovExposer;
    Panel: TPanel;
    DBNavigator: TDBNavigator;
    AddressExposer: TovExposer;
    AddressSource: TDataSource;
    DBImage: TDBImage;
    Label4: TLabel;
    ChangeImageBtn: TButton;
    GroupBox1: TGroupBox;
    DBEdit5: TDBEdit;
    Label5: TLabel;
    DBEdit6: TDBEdit;
    Label8: TLabel;
    DBEdit7: TDBEdit;
    Label9: TLabel;
    DBEdit8: TDBEdit;
    Label10: TLabel;
    GroupBox2: TGroupBox;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    DBEdit4: TDBEdit;
    DBComboBox2: TDBComboBox;
    Label7: TLabel;
    Label6: TLabel;
    Label2: TLabel;
    Label1: TLabel;
    Label3: TLabel;
    DBText1: TDBText;
    Label11: TLabel;
    DBLookupComboBox1: TDBLookupComboBox;
    Label12: TLabel;
    FullAddress: TStringField;
    ClearImageBtn: TButton;
    LookupPersonSource: TDataSource;
    LookupPersonExposer: TovExposer;
    FullName: TStringField;
    LookupPersonExposerId: TIntegerField;
    AddressExposerDSDesigner: TStringField;
    AddressExposerDSDesigner2: TStringField;
    AddressExposerDSDesigner3: TStringField;
    AddressExposerDSDesigner4: TSmallintField;
    PersonExposerDSDesigner: TIntegerField;
    PersonExposerDSDesigner2: TStringField;
    PersonExposerDSDesigner3: TStringField;
    PersonExposerDSDesigner4: TStringField;
    PersonExposerDSDesigner5: TStringField;
    PersonExposerDSDesigner6: TDateField;
    PersonExposerDSDesigner7: TGraphicField;
    PersonExposerIntegerField: TStringField;
    LookupPersonExposerDSDesigner: TStringField;
    LookupPersonExposerDSDesigner2: TStringField;
    LookupPersonExposerDSDesigner3: TStringField;
    LookupPersonExposerDSDesigner4: TStringField;
    LookupPersonExposerDSDesigner5: TDateField;
    LookupPersonExposerDSDesigner6: TGraphicField;
    procedure PersonExposerBeforeScroll(DataSet: TDataSet);
    procedure AddressExposerCalcFields(DataSet: TDataSet);
    procedure ChangeImageBtnClick(Sender: TObject);
    procedure ClearImageBtnClick(Sender: TObject);
    procedure LookupPersonExposerCalcFields(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FieldDemoForm: TFieldDemoForm;

implementation

uses Data;

{$R *.dfm}

procedure TFieldDemoForm.PersonExposerBeforeScroll(DataSet: TDataSet);
begin
  AddressExposer.CheckBrowseMode
end;

procedure TFieldDemoForm.AddressExposerCalcFields(DataSet: TDataSet);
begin
  with AddressExposer do
    if Not VarIsNull(FieldValues['']) then
      FullAddress.Value := Format('. %s . %s . %s . %s',
        [FieldValues[''], FieldValues[''],
         FieldValues[''], FieldValues['']])
    else
      FullAddress.Value := ''
end;

procedure TFieldDemoForm.LookupPersonExposerCalcFields(DataSet: TDataSet);
begin
  with LookupPersonExposer do
    FullName.Value := Format('%s %s %s',
      [FieldValues[''], FieldValues[''], FieldValues['']])
end;

procedure TFieldDemoForm.ChangeImageBtnClick(Sender: TObject);
var
  Picture: TPicture;
begin
  with TOpenPictureDialog.Create(nil) do
  try
    if Execute then
    begin
      PersonExposer.Edit;
      Picture := TPicture.Create;
      try
        Picture.LoadFromFile(FileName);
        DBImage.Picture.Assign(Picture);
      finally
        Picture.Free;
      end;
      PersonExposer.Post
    end;
  finally
    Free;
  end;
end;

procedure TFieldDemoForm.ClearImageBtnClick(Sender: TObject);
begin
  PersonExposer.Edit;
  DBImage.Field.Clear;
  PersonExposer.Post
end;

end.
