unit ovBDEParams;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBTables, Buttons, DBCtrls, AppEvnts;

type
  TovBDEAdapterParams = class(TForm)
    OkBtn: TButton;
    CancelBtn: TButton;
    cbAlias: TComboBox;
    Label1: TLabel;
    Session: TSession;
    Label2: TLabel;
    mmParams: TMemo;
    Label5: TLabel;
    AliasParamsBtn: TBitBtn;
    cbDriver: TComboBox;
    ApplicationEvents: TApplicationEvents;
    procedure FormCreate(Sender: TObject);
    procedure cbAliasChange(Sender: TObject);
    procedure cbDriverChange(Sender: TObject);
    procedure ApplicationEventsIdle(Sender: TObject; var Done: Boolean);
    procedure AliasParamsBtnClick(Sender: TObject);
  private
    procedure SetParams(Params: TStrings);
    procedure GetParams(Params: TStrings);
    { Private declarations }
  public
    { Public declarations }
  end;

function ShowAdapterParams(Params: TStrings): Boolean;

implementation

{$R *.DFM}

function ShowAdapterParams(Params: TStrings): Boolean;
begin
  with TovBDEAdapterParams.Create(Application) do
  try
    SetParams(Params);
    Result := ShowModal = mrOk;
    if Result then GetParams(Params);
  finally
    Free
  end;
end;

{ TovBDEAdapterParams }

procedure TovBDEAdapterParams.SetParams(Params: TStrings);
begin
  mmParams.Lines.Assign(Params);
  mmParams.Lines.Values['AliasName'] := '';
  mmParams.Lines.Values['DriverName'] := '';

  cbAlias.Text := Params.Values['AliasName'];
  cbDriver.Text := Params.Values['DriverName'];
end;

procedure TovBDEAdapterParams.GetParams(Params: TStrings);
begin
  Params.Assign(mmParams.Lines);

  Params.Values['AliasName'] := cbAlias.Text;
  Params.Values['DriverName'] := cbDriver.Text;
end;

procedure TovBDEAdapterParams.FormCreate(Sender: TObject);
begin
  Session.GetAliasNames(cbAlias.Items);
  Session.GetDriverNames(cbDriver.Items);
end;

procedure TovBDEAdapterParams.cbAliasChange(Sender: TObject);
begin
  cbDriver.ItemIndex := -1;
  mmParams.Lines.Clear;
end;

procedure TovBDEAdapterParams.cbDriverChange(Sender: TObject);
begin
  cbAlias.ItemIndex := -1;
end;

procedure TovBDEAdapterParams.ApplicationEventsIdle(Sender: TObject;
  var Done: Boolean);
begin
  mmParams.Enabled := cbDriver.ItemIndex >= 0;
  AliasParamsBtn.Enabled := cbAlias.ItemIndex >= 0;
end;

procedure TovBDEAdapterParams.AliasParamsBtnClick(Sender: TObject);
begin
  Session.GetAliasParams(cbAlias.Text, mmParams.Lines);
end;

end.


