unit ovDBISAMParams;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

type
  TovDBISAMAdapterParams = class(TForm)
    GroupBox6: TGroupBox;
    Label10: TLabel;
    Label11: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    HostNameEdit: TEdit;
    PortEdit: TEdit;
    IPAddressEdit: TEdit;
    ServiceEdit: TEdit;
    LANRadioButton: TRadioButton;
    InternetRadioButton: TRadioButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    rgSessionType: TRadioGroup;
    OpenBtn: TSpeedButton;
    edDirectory: TEdit;
    OkBtn: TButton;
    CancelBtn: TButton;
    procedure rgSessionTypeClick(Sender: TObject);
    procedure OpenBtnClick(Sender: TObject);
  private
    procedure SetParams(Params: TStrings);
    procedure GetParams(Params: TStrings);
    { Private declarations }
  public
    { Public declarations }
  end;

function EditAdapterParams(Params: TStrings): Boolean;

implementation

uses FileCtrl;

{$R *.DFM}

function EditAdapterParams(Params: TStrings): Boolean;
begin
  with TovDBISAMAdapterParams.Create(Application) do
  try
    SetParams(Params);
    Result := ShowModal = mrOk;
    if Result then GetParams(Params);
  finally
    Free
  end;
end;

{ TovDBISAMAdapterParams }

procedure TovDBISAMAdapterParams.SetParams(Params: TStrings);
begin
  edDirectory.Text := Params.Values['Directory'];
end;

procedure TovDBISAMAdapterParams.GetParams(Params: TStrings);
begin
  Params.Values['Directory'] := edDirectory.Text;
  Params.Values['SessionType'] := 'Local';
end;

procedure TovDBISAMAdapterParams.rgSessionTypeClick(Sender: TObject);
begin
  rgSessionType.ItemIndex := 0
end;

procedure TovDBISAMAdapterParams.OpenBtnClick(Sender: TObject);
var
  NewDir: String;
begin
  NewDir := edDirectory.Text;
  if SelectDirectory(NewDir, [sdAllowCreate, sdPerformCreate, sdPrompt], 0)
    then edDirectory.Text := NewDir
end;

end.
