unit ovNexusDB1Params;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

type
  TovNexusDB1AdapterParams = class(TForm)
    GroupBox6: TGroupBox;
    Label10: TLabel;
    Label11: TLabel;
    edServerName: TEdit;
    edDatabaseAlias: TEdit;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    rgSessionType: TRadioGroup;
    OpenBtn: TSpeedButton;
    edDirectory: TEdit;
    OkBtn: TButton;
    CancelBtn: TButton;
    procedure rgSessionTypeClick(Sender: TObject);
    procedure OpenBtnClick(Sender: TObject);
  private
    procedure SetParams(Params: TStrings);
    procedure GetParams(Params: TStrings);
    { Private declarations }
  public
    { Public declarations }
  end;

function ShowAdapterParams(Params: TStrings): Boolean;

var
  ovNexusDB1AdapterParams: TovNexusDB1AdapterParams;

implementation

uses FileCtrl;

{$R *.DFM}

function ShowAdapterParams(Params: TStrings): Boolean;
begin
  with TovNexusDB1AdapterParams.Create(Application) do
  try
    SetParams(Params);
    Result := ShowModal = mrOk;
    if Result then GetParams(Params);
  finally
    Free
  end;
end;

{ TovNexusDB1AdapterParams }

procedure TovNexusDB1AdapterParams.SetParams(Params: TStrings);
begin
  edDirectory.Text := Params.Values['DatabaseDirectory'];
  edServerName.Text := Params.Values['ServerName'];
  edDatabaseAlias.Text := Params.Values['DatabaseAliasName'];
  if Params.Values['ServerName'] <> '' then
    rgSessionType.ItemIndex := 1
  else
    rgSessionType.ItemIndex := 0
end;

procedure TovNexusDB1AdapterParams.GetParams(Params: TStrings);
begin
  Params.Values['DatabaseDirectory'] := edDirectory.Text;
  Params.Values['ServerName'] := edServerName.Text;
  Params.Values['DatabaseAliasName'] := edDatabaseAlias.Text;
  if rgSessionType.ItemIndex = 1
    then Params.Values['DatabaseDirectory'] := '';
end;

procedure TovNexusDB1AdapterParams.rgSessionTypeClick(Sender: TObject);
begin
  edDirectory.Enabled := rgSessionType.ItemIndex = 0;
  edServerName.Enabled := rgSessionType.ItemIndex = 1;
  edDatabaseAlias.Enabled := rgSessionType.ItemIndex = 1;
end;

procedure TovNexusDB1AdapterParams.OpenBtnClick(Sender: TObject);
var
  NewDir: String;
begin
  NewDir := edDirectory.Text;
  if SelectDirectory(NewDir, [sdAllowCreate, sdPerformCreate, sdPrompt], 0)
    then edDirectory.Text := NewDir
end;

end.
