unit ovFReportDataLinksExplorer;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ImgList, AppEvnts, ActnList, ComCtrls, ToolWin,
  ovDataLinks, ovFReportLinks, ovDataLinksExplorer, frxDBSet;

type
  TfrmFReportDataLinksExplorer = class(TfrmDataLinksExplorer)
  private
    { Private declarations }
  protected
    function CanLink(AComponent: TComponent): Boolean; override;
    function GetObjectInfo(AObject: TPersistent; var ATitle, ADataObject,
      AnAttribute, ALookupDataObject, ALookupAttributes: String): Boolean; override;
  public
    procedure AddDataObjectLink(DataObjectName: String; ObjectIndex: Integer); 
      override;
    procedure AddAttributeLink(DataObjectName: String; Attributes: TStrings; 
      ObjectIndex: Integer); override;
    procedure AddLookupLink(ALookupDataObjectName, ALookupAttributes: String; 
      ObjectIndex: Integer); override;
    { Public declarations }
  end;

var
  frmFReportDataLinksExplorer: TfrmFReportDataLinksExplorer;

implementation

uses ovUtils, frxClass;

{$R *.dfm}

function TfrmFReportDataLinksExplorer.CanLink(AComponent: TComponent): Boolean;
begin
  Result := AComponent is TfrxDBDataset
end;

function TfrmFReportDataLinksExplorer.GetObjectInfo(AObject: TPersistent; var
  ATitle, ADataObject, AnAttribute, ALookupDataObject, ALookupAttributes:
  String): Boolean;
begin
  Result := inherited GetObjectInfo(AObject,
    ATitle, ADataObject, AnAttribute, ALookupDataObject, ALookupAttributes);

  if AObject is TfrxDBDataset then
    ATitle := TfrxDBDataset(AObject).UserName
end;

procedure TfrmFReportDataLinksExplorer.AddDataObjectLink(DataObjectName:
  String; ObjectIndex: Integer);
var
  AObject: TObject;
  Link: TovDataLink;
begin
  AObject := GetObjectAt(ObjectIndex);
  if AObject = nil then
  begin
    AObject := TfrxDBDataset.Create(DataLinks.Owner);
    TfrxDBDataset(AObject).UserName := DataObjectName;
    GenerateComponentName(TfrxDBDataset(AObject));
  end;
  if AObject is TfrxDBDataset then
  begin
    Link := GetLinkAt(ObjectIndex);
    if Link <> nil then
      Link.DataObject := DataObjectName
    else
      DataLinks.AddLink(TovFReportDataLinkController, TComponent(AObject), DataObjectName, '');
    ShowComponentList;
  end
end;

{{
    
}
procedure TfrmFReportDataLinksExplorer.AddAttributeLink(DataObjectName:
  String; Attributes: TStrings; ObjectIndex: Integer);
begin
end;

{{
    
}
procedure TfrmFReportDataLinksExplorer.AddLookupLink(ALookupDataObjectName,
  ALookupAttributes: String; ObjectIndex: Integer);
begin
end;

initialization
  RegisterDataLinkExplorer('   FastReport', TfrmFReportDataLinksExplorer);
finalization
  UnregisterDataLinkExplorer(TfrmFReportDataLinksExplorer);
end.
