unit ovSSDBForms;

interface

uses Classes, ovDataObjects, ssDBForms, DB;

type
  TovDBSpreadsheetForms = class(TCustomDBSpreadSheetForms)
  private
    FDataObjects: TovDataObjects;
    procedure SetDataObjects(const Value: TovDataObjects);
  protected
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    function GetFieldDataSource(AField: TssDBFormField; ADataSourceName: String):
      TDataSource; override;
  public
    procedure Assign(Source: TPersistent); override;
  published
    property DataObjects: TovDataObjects read FDataObjects write SetDataObjects;
  end;

implementation

{ TovDBSpreadsheetForms }

procedure TovDBSpreadsheetForms.SetDataObjects(const Value: TovDataObjects);
begin
  if FDataObjects <> Value then
  begin
    FDataObjects := Value;
    if Value <> nil then Value.FreeNotification(Self);
  end;
end;

procedure TovDBSpreadsheetForms.Notification(AComponent: TComponent; Operation:
  TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (AComponent = DataObjects)then DataObjects := nil;
end;

procedure TovDBSpreadsheetForms.Assign(Source: TPersistent);
begin
  inherited;
  if Source is TovDBSpreadsheetForms then
    DataObjects := TovDBSpreadsheetForms(Source).DataObjects
end;

function TovDBSpreadsheetForms.GetFieldDataSource(AField: TssDBFormField;
  ADataSourceName: String): TDataSource;
begin
  if ADataSourceName <> '' then
    Result := DataObjects.DataSources[ADataSourceName]
  else
    Result := nil
end;

end.
 