unit ovSSReportReg;

interface

uses Classes, DesignEditors, DesignIntf;

type
  TSpreadSheetDBFormsEditor = class(TComponentEditor)
  public
    function GetVerb(Index: Integer):string; override;
    function GetVerbCount: Integer; override;
    procedure ExecuteVerb(Index: Integer); override;
  end;

  TSpreadSheetObjFormsEditor = class(TComponentEditor)
  public
    function GetVerb(Index: Integer):string; override;
    function GetVerbCount: Integer; override;
    procedure ExecuteVerb(Index: Integer); override;
  end;

procedure Register;

implementation

uses ovSSDBForms, sdDesigner, sdDBFormDesigner, ovSSForms, sdObjFormDesigner;

procedure Register;
begin
  RegisterComponents('ObjectView Misc', [TovDBSpreadsheetForms, TovSpreadSheetForms]);
  RegisterComponentEditor(TovDBSpreadsheetForms, TSpreadSheetDBFormsEditor);
  RegisterComponentEditor(TovSpreadSheetForms, TSpreadSheetObjFormsEditor);
end;

{ TSpreadSheetDBFormsEditor }

procedure TSpreadSheetDBFormsEditor.ExecuteVerb(Index: Integer);
begin
  if ShowSpreadSheetDesigner(Component as TovDBSpreadsheetForms, TfrmDBFormDesigner)
    then Designer.Modified
end;

function TSpreadSheetDBFormsEditor.GetVerb(Index: Integer): string;
begin
  Result := ' ..';
end;

function TSpreadSheetDBFormsEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

{ TSpreadSheetObjFormsEditor }

procedure TSpreadSheetObjFormsEditor.ExecuteVerb(Index: Integer);
begin
  if ShowSpreadSheetDesigner(Component as TovSpreadSheetForms, TfrmObjFormDesigner)
    then Designer.Modified
end;

function TSpreadSheetObjFormsEditor.GetVerb(Index: Integer): string;
begin
  Result := ' ..';
end;

function TSpreadSheetObjFormsEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

end.
