unit ovSSReportsLinks;

interface

uses SysUtils, Classes, DB, ovDataObjects, ovDataLinks, ssReports;

type
  TovSSReportsDataLinkController = class(TovDataLinkController)
  private
    FDataSource: TssReportDataSource;
    FDataSourceName: String;
    procedure SetDataSourceName(const Value: String);
  protected
    procedure SetActive(Value: Boolean); override;
    procedure Loaded; override;
  public
    property DataSource: TssReportDataSource read FDataSource;
  published
    property DataSourceName: String read FDataSourceName write SetDataSourceName;
  end;

implementation

{
************************* TovSReportDataLinkController *************************
}

procedure TovSSReportsDataLinkController.Loaded;
begin
  inherited;
  with Link do
    if Assigned(Component) and (Component is TSpreadSheetReports) then
      FDataSource := TSpreadSheetReports(Component).GetDataSource(DataSourceName) as TssReportDataSource;
end;

procedure TovSSReportsDataLinkController.SetActive(Value: Boolean);
var
  DataSource: TssReportDataSource;
begin
  with Link do
  begin
    if Component = nil then
      raise Exception.Create('     ');

    if Not (Component is TSpreadSheetReports) then
      raise Exception.Create('   ');

    if Value then
    begin
      DataSource := TSpreadSheetReports(Component).GetDataSource(DataSourceName) as TssReportDataSource;
      DataSource.DataSet := Owner.DataObjects[DataObject];
    end;
  end
end;

procedure TovSSReportsDataLinkController.SetDataSourceName(const Value: String);
begin
  FDataSourceName := Value;
  with Link do
    if Assigned(Component) and (Component is TSpreadSheetReports) then
      FDataSource := TSpreadSheetReports(Component).GetDataSource(DataSourceName) as TssReportDataSource;
end;

initialization
  RegisterDataLinkController(TovSSReportsDataLinkController);
finalization
  UnregisterDataLinkController(TovSSReportsDataLinkController);
end.
