unit ovDataSetExplorer;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, DB, DBGrids, StdCtrls, Buttons, DBCtrls, ExtCtrls;

type
  TfmExploreDataSet = class(TForm)
    Grid: TDBGrid;
    DataSource: TDataSource;
    Panel: TPanel;
    DBNavigator: TDBNavigator;
    CancelBtn: TBitBtn;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    FIsModal: Boolean;
    { Private declarations }
  protected
    property IsModal: Boolean read FIsModal;
  public
    { Public declarations }
  end;

procedure ExploreDataSetModal(ADataSet: TDataSet; ACaption: String);
procedure ExploreDataSetNonModal(ADataSet: TDataSet; ACaption: String);

implementation

{$R *.dfm}

procedure ExploreDataSetModal(ADataSet: TDataSet; ACaption: String);
begin
  with TfmExploreDataSet.Create(Application) do
  try
    FIsModal := True;
    Caption := ACaption;
    DataSource.DataSet := ADataSet;
    ShowModal;
  finally
    Free
  end;
end;

procedure ExploreDataSetNonModal(ADataSet: TDataSet; ACaption: String);
begin
  with TfmExploreDataSet.Create(Application) do
  begin
    FIsModal := False;
    Caption := ACaption;
    DataSource.DataSet := ADataSet;
    InsertComponent(ADataSet);
    Show;
  end;
end;

procedure TfmExploreDataSet.FormClose(Sender: TObject; var Action:
  TCloseAction);
begin
  if Not IsModal then Action := caFree;
end;

end.
