unit ovOQLGrammar;




{==============================================================================
ovOQLGrammar
1.0.0.0
Date of Generation: 24.12.2007 12:39
Comment: Object Query Launguage Grammar
Author: Kuznetsov Maksim
Copyright: Copyright  2007, All rights reserved.

This unit was generated by Coco/R for Delphi (www.tetzel.com)  Any code in
this file that you edit manually will be over-written when the file is
regenerated.
==============================================================================}

interface
uses  SysUtils,Classes,CocoBase,Contnrs,ovOQLTypes,mwStringHashList;



const
maxT = 65;
type

  SymbolSet = array[0..maxT div setsize] of TBitSet;

  EovOQLGrammar = class(Exception);
  TovOQLGrammar = class;

  TovOQLGrammarScanner = class(TCocoRScanner)
  private
    FOwner : TovOQLGrammar;
fHashList: TmwStringHashList;
function CharInIgnoreSet(const Ch : char) : boolean;
procedure CheckLiteral(var Sym : integer);
function GetNextSymbolString: string;
    function Comment : boolean;
  protected
    procedure NextCh; override;
  public
    constructor Create;
destructor Destroy; override;

    procedure Get(var sym : integer); override; // Gets next symbol from source file

    property CurrentSymbol;
    property NextSymbol;
    property OnStatusUpdate;
    property Owner : TovOQLGrammar read fOwner write fOwner;
    property ScannerError;
    property SrcStream;
  end;  { TovOQLGrammarScanner }

  TovOQLGrammar = class(TCocoRGrammar)
  private
    { strictly internal variables }
    symSet : array[0..7] of SymbolSet; // symSet[0] = allSyncSyms

    function GetBuildDate : TDateTime;
    function GetVersion : string;
    function GetVersionStr : string;
    procedure SetVersion(const Value : string);
    function GetVersionInfo : string;
    function _In(var s : SymbolSet; x : integer) : boolean;
    procedure InitSymSet;
function WeakSeparator(n, syFol, repFol : integer) : boolean;
procedure ExpectWeak(n, follow : integer);

    {Production methods}
    procedure _BetweenExpr;
    procedure _InSetExpr;
    procedure _NullTest;
    procedure _LikeTest;
    procedure _WordOperator;
    procedure _MathOperator;
    procedure _TestExpr;
    procedure _Operator;
    procedure _Term;
    procedure _NotOperator;
    procedure _Relation;
    procedure _SimpleExpression;
    procedure _OrderByField;
    procedure _Param;
    procedure _Null;
    procedure _Field;
    procedure _ColumnFunction;
    procedure _FunctionExpr;
    procedure _SelectField;
    procedure _OrderByFldList;
    procedure _Alias;
    procedure _QualifiedTable;
    procedure _SearchCondition;
    procedure _FetchRelationList;
    procedure _FromTableList;
    procedure _SelectFieldList;
    procedure _OrderByClause;
    procedure _HavingClause;
    procedure _GroupByClause;
    procedure _FetchClause;
    procedure _FromClause;
    procedure _SelectClause;
    procedure _FieldList;
    procedure _CloseParens;
    procedure _ColumnList;
    procedure _OpenParens;
    procedure _ItemSeparator;
    procedure _Expression;
    procedure _ColumnName;
    procedure _UpdateField;
    procedure _WhereClause;
    procedure _UpdateFieldList;
    procedure _Table;
    procedure _DeleteStmt;
    procedure _InsertStmt;
    procedure _UpdateStmt;
    procedure _SubSelectSQL;
    procedure _SelectStmt;
    procedure _DeleteSQL;
    procedure _InsertSQL;
    procedure _UpdateSQL;
    procedure _SelectSQL;
    procedure _ovOQLGrammar;

  private
    FSelectStatement: TSelectStatement;
    FSelectStatements: TObjectList;
    FCurrentExpression: TQueryStatementExpression;
    procedure Init;
    procedure Final;

    function GetSelectStatements(Index: Integer): TSelectStatement;
    function GetSelectStatementCount: Integer;
    function NewSelectStatement: TSelectStatement;
    procedure AddToken(TokenKind: TTokenType); overload;
    procedure AddToken(TokenText: String; TokenKind: TTokenType); overload;
    procedure AddKeyword(TokenKind: TTokenType);

    procedure WriteKeyword;
    procedure WriteType(S : string);

  protected
    { Protected Declarations }
    procedure Get; override;
  public
    { Public Declarations }
    constructor Create(AOwner : TComponent); override;
    destructor Destroy; override;

    function ErrorStr(const ErrorCode : integer; const Data : string) : string; override;
    procedure Execute;
    function GetScanner : TovOQLGrammarScanner;
    procedure Parse;

    property ErrorList;
    property ListStream;
    property SourceStream;
    property Successful;
    property BuildDate : TDateTime read GetBuildDate;
    property VersionStr : string read GetVersionStr;
    property VersionInfo : string read GetVersionInfo;

  public
    property SelectStatements[Index: Integer]: TSelectStatement read
        GetSelectStatements;
    property SelectStatementCount: Integer read GetSelectStatementCount;

    property SelectStatement: TSelectStatement read FSelectStatement;

  published
    { Published Declarations }
    property AfterGet;
    property AfterParse;
    property AfterGenList;
    property BeforeGenList;
    property BeforeParse;
    property ClearSourceStream;
    property GenListWhen;
    property SourceFileName;
property Version : string read GetVersion write SetVersion;

    property OnCustomError;
    property OnError;
    property OnFailure;
    property OnStatusUpdate;
    property OnSuccess;
  end; { TovOQLGrammar }

implementation



const

  EOFSYMB = 0;  identSym = 1;  IdentWithLBracketSym = 2;  NextIdentSym = 3;
  integer_Sym = 4;  floatSym = 5;  SQLStringSym = 6;  _semicolonSym = 7;
  UNIONSym = 8;  ALLSym = 9;  UPDATESym = 10;  SETSym = 11;  _equalSym = 12;
  INSERTSym = 13;  INTOSym = 14;  VALUESSym = 15;  DELETESym = 16;
  FROMSym = 17;  SELECTSym = 18;  DISTINCTSym = 19;  FETCHSym = 20;
  _rbrackSym = 21;  EXISTINGSym = 22;  WITHSym = 23;  ASSym = 24;
  WHERESym = 25;  HAVINGSym = 26;  ORDERSym = 27;  BYSym = 28;  GROUPSym = 29;
  _lbrack_star_rbrackSym = 30;  TIMESTAMPSym = 31;  UPPERSym = 32;
  MONTHSym = 33;  YEARSym = 34;  COUNTSym = 35;  SUMSym = 36;  MAXSym = 37;
  MINSym = 38;  AVGSym = 39;  _starSym = 40;  _point_starSym = 41;
  NULLSym = 42;  DESCSym = 43;  ASCSym = 44;  _minusSym = 45;  _colonSym = 46;
  NOTSym = 47;  _slashSym = 48;  _plusSym = 49;  ANDSym = 50;  ORSym = 51;
  LIKESym = 52;  ESCAPESym = 53;  ISSym = 54;  _less_greaterSym = 55;
  _lessSym = 56;  _less_equalSym = 57;  _greaterSym = 58;
  _greater_equalSym = 59;  BETWEENSym = 60;  INSym = 61;  _commaSym = 62;
  _lparenSym = 63;  _rparenSym = 64;  NOSYMB = 65;  _noSym = NOSYMB;   {error token code}

{ --------------------------------------------------------------------------- }
{ Arbitrary Code from ATG file }
procedure TovOQLGrammar.Init;
begin
  FSelectStatement := nil;
  FSelectStatements.Clear;
end;

procedure TovOQLGrammar.Final;
begin
end;

function TovOQLGrammar.GetSelectStatements(Index: Integer): TSelectStatement;
begin
  Result := TSelectStatement(FSelectStatements[Index]);
end;

function TovOQLGrammar.GetSelectStatementCount: Integer;
begin
  Result := FSelectStatements.Count;
end;

function TovOQLGrammar.NewSelectStatement: TSelectStatement;
begin
  Result := TSelectStatement.Create;
  FSelectStatements.Add(Result);
end;

procedure TovOQLGrammar.AddToken(TokenText: String; TokenKind: TTokenType);
begin
  if Not Assigned(FCurrentExpression) then raise Exception.Create('   FCurrentExpression');
  with FCurrentExpression.AddItem do
  begin
    ItemText := TokenText;
    ItemType := TokenKind;
  end
end;

procedure TovOQLGrammar.AddToken(TokenKind: TTokenType);
begin
  AddToken(LexString, TokenKind);
end;

{{
,  AddToken,    
}
procedure TovOQLGrammar.AddKeyword(TokenKind: TTokenType);
begin
  AddToken(UpperCase(LexString), TokenKind);
end;

procedure TovOQLGrammar.WriteKeyword;
begin
end;

procedure TovOQLGrammar.WriteType(S : string);
begin
end;

(* End of Arbitrary Code *)



{ --------------------------------------------------------------------------- }
{ ---- implementation for TovOQLGrammarScanner ---- }

procedure TovOQLGrammarScanner.NextCh;
{ Return global variable ch }
begin
  LastInputCh := CurrInputCh;
  BufferPosition := BufferPosition + 1;
  SrcStream.Seek(BufferPosition,soFromBeginning);
  CurrInputCh := CurrentCh(BufferPosition);
  if (CurrInputCh = _EL) OR ((CurrInputCh = _LF) AND (LastInputCh <> _EL)) then
  begin
    CurrLine := CurrLine + 1;
    if Assigned(OnStatusUpdate) then
      OnStatusUpdate(Owner, cstLineNum, '', CurrLine);
    StartOfLine := BufferPosition;
  end
end;  {NextCh}

function TovOQLGrammarScanner.Comment : boolean;
var
  level : integer;
  startLine : integer;
  oldLineStart : longint;
  CommentStr : string;
begin
  level := 1;
  startLine := CurrLine;
  oldLineStart := StartOfLine;
  CommentStr := CharAt(BufferPosition);
Result := false;
if (CurrInputCh = '-') then
  begin
NextCh;
CommentStr := CommentStr + CharAt(BufferPosition);
if (CurrInputCh = '-') then
begin
NextCh;
CommentStr := CommentStr + CharAt(BufferPosition);
while true do
begin
if (CurrInputCh = CHR(13)) then
begin
level := level - 1;
NumEOLInComment := CurrLine - startLine;
NextCh;
CommentStr := CommentStr + CharAt(BufferPosition);
if level = 0 then
begin
  Result := true;
  Exit;
end;
end
else if (CurrInputCh = '-') then
begin
NextCh;
CommentStr := CommentStr + CharAt(BufferPosition);
if (CurrInputCh = '-') then
begin
  level := level + 1;
  NextCh;
CommentStr := CommentStr + CharAt(BufferPosition);
end
end
else if CurrInputCh = _EF then
begin
  Result := false;
  Exit;
end
else
begin
  NextCh;
  CommentStr := CommentStr + CharAt(BufferPosition);
end;
end; { WHILE TRUE }
end
else
begin
if (CurrInputCh = _CR) OR (CurrInputCh = _LF) then
begin
CurrLine := CurrLine - 1;
StartOfLine := oldLineStart
end;
BufferPosition := BufferPosition - 1;
CurrInputCh := LastInputCh;
Result := false;
end;
end;
Result := false;
if (CurrInputCh = '/') then
  begin
NextCh;
CommentStr := CommentStr + CharAt(BufferPosition);
if (CurrInputCh = '*') then
begin
NextCh;
CommentStr := CommentStr + CharAt(BufferPosition);
while true do
begin
if (CurrInputCh = '*') then
begin
NextCh;
CommentStr := CommentStr + CharAt(BufferPosition);
if (CurrInputCh = '/') then
begin
level := level - 1;
NextCh;
CommentStr := CommentStr + CharAt(BufferPosition);
if level = 0 then
begin
  Result := true;
  Exit;
end
end
end
else if (CurrInputCh = '/') then
begin
NextCh;
CommentStr := CommentStr + CharAt(BufferPosition);
if (CurrInputCh = '*') then
begin
  level := level + 1;
  NextCh;
CommentStr := CommentStr + CharAt(BufferPosition);
end
end
else if CurrInputCh = _EF then
begin
  Result := false;
  Exit;
end
else
begin
  NextCh;
  CommentStr := CommentStr + CharAt(BufferPosition);
end;
end; { WHILE TRUE }
end
else
begin
if (CurrInputCh = _CR) OR (CurrInputCh = _LF) then
begin
CurrLine := CurrLine - 1;
StartOfLine := oldLineStart
end;
BufferPosition := BufferPosition - 1;
CurrInputCh := LastInputCh;
Result := false;
end;
end;
end;  { Comment }

function TovOQLGrammarScanner.CharInIgnoreSet(const Ch : char) : boolean;
begin
Result := (Ch = ' ')    OR
((CurrInputCh >= CHR(1)) AND (CurrInputCh <= ' '));
end; {CharInIgnoreSet}

function TovOQLGrammarScanner.GetNextSymbolString: string;
var
  i: integer;
  q: integer;
begin
  Result := '';
  i := 1;
  q := bpCurrToken;
  while i <= NextSymbol.Len do
  begin
    Result := Result + CurrentCh(q);
    inc(q);
    inc(i);
  end;
end; {GetNextSymbolString}

procedure TovOQLGrammarScanner.CheckLiteral(var Sym : integer);
var
  SymId : integer;
  DefaultSymId : integer;
  aToken : string;
begin
  aToken := GetNextSymbolString;
  if fHashList.Hash(aToken, SymId, DefaultSymId) then
  begin
      sym := SymId;
  end;
end; {CheckLiteral}


procedure TovOQLGrammarScanner.Get(var sym : integer);
var
  state : integer;
begin   {Get}
while CharInIgnoreSet(CurrInputCh) do
  NextCh;
if ((CurrInputCh = '-') OR (CurrInputCh = '/')) AND Comment then
begin
  Get(sym);
  exit;
  end;

  LastSymbol.Assign(CurrentSymbol);
  CurrentSymbol.Assign(NextSymbol);

  NextSymbol.Pos := BufferPosition;
  NextSymbol.Col := BufferPosition - StartOfLine;
  NextSymbol.Line := CurrLine;
  NextSymbol.Len := 0;

  ContextLen := 0;
  state := StartState[ORD(CurrInputCh)];
  bpCurrToken := BufferPosition;
  while true do
  begin
    NextCh;
    NextSymbol.Len := NextSymbol.Len + 1;
    if BufferPosition > SrcStream.Size then
    begin
      sym := EOFSYMB;
      CurrInputCh := _EF;
      BufferPosition := BufferPosition - 1;
      exit
    end;
    case state of
   1: if ((CurrInputCh = '!') OR
(CurrInputCh >= '#') AND (CurrInputCh <= '$') OR
(CurrInputCh >= '0') AND (CurrInputCh <= '9') OR
(CurrInputCh >= '@') AND (CurrInputCh <= 'Z') OR
(CurrInputCh = '\') OR
(CurrInputCh >= '^') AND (CurrInputCh <= '{') OR
(CurrInputCh >= '}')) then
begin
 
end
else
begin
sym := identSym;
CheckLiteral(sym);
exit;
end;
   2: if ((CurrInputCh = '!') OR
(CurrInputCh >= '#') AND (CurrInputCh <= '$') OR
(CurrInputCh >= '@') AND (CurrInputCh <= 'Z') OR
(CurrInputCh = '\') OR
(CurrInputCh >= '^') AND (CurrInputCh <= '{') OR
(CurrInputCh >= '}')) then
begin
state := 3; 
end
else if (CurrInputCh = '*') then
begin
state := 14; 
end
else
begin
  sym := _noSym;
exit;
end;
   3: if ((CurrInputCh >= ' ') AND (CurrInputCh <= '!') OR
(CurrInputCh >= '#') AND (CurrInputCh <= '$') OR
(CurrInputCh >= '0') AND (CurrInputCh <= ':') OR
(CurrInputCh >= '@') AND (CurrInputCh <= 'Z') OR
(CurrInputCh = '\') OR
(CurrInputCh >= '^') AND (CurrInputCh <= '{') OR
(CurrInputCh >= '}')) then
begin
 
end
else
begin
sym := IdentWithLBracketSym;
exit;
end;
   4: if ((CurrInputCh >= ' ') AND (CurrInputCh <= '!') OR
(CurrInputCh >= '#') AND (CurrInputCh <= '$') OR
(CurrInputCh >= '0') AND (CurrInputCh <= '9') OR
(CurrInputCh >= '@') AND (CurrInputCh <= 'Z') OR
(CurrInputCh = '\') OR
(CurrInputCh >= '^') AND (CurrInputCh <= '{') OR
(CurrInputCh >= '}')) then
begin
 
end
else
begin
sym := NextIdentSym;
exit;
end;
   5: if ((CurrInputCh >= '0') AND (CurrInputCh <= '9')) then
begin
state := 6; 
end
else
begin
  sym := _noSym;
exit;
end;
   6: if ((CurrInputCh >= '0') AND (CurrInputCh <= '9')) then
begin
 
end
else
begin
sym := floatSym;
exit;
end;
   7: if ((CurrInputCh <= CHR(12)) OR
(CurrInputCh >= CHR(14)) AND (CurrInputCh <= '&') OR
(CurrInputCh >= '(')) then
begin
 
end
else if (CurrInputCh = CHR(39)) then
begin
state := 10; 
end
else
begin
  sym := _noSym;
exit;
end;
   8: if ((CurrInputCh >= '0') AND (CurrInputCh <= '9')) then
begin
 
end
else if (CurrInputCh = '.') then
begin
state := 5; 
end
else
begin
sym := integer_Sym;
exit;
end;
   9: if ((CurrInputCh = '!') OR
(CurrInputCh >= '#') AND (CurrInputCh <= '$') OR
(CurrInputCh >= '@') AND (CurrInputCh <= 'Z') OR
(CurrInputCh = '\') OR
(CurrInputCh >= '^') AND (CurrInputCh <= '{') OR
(CurrInputCh >= '}')) then
begin
state := 4; 
end
else if ((CurrInputCh >= '0') AND (CurrInputCh <= '9')) then
begin
state := 6; 
end
else if (CurrInputCh = '*') then
begin
state := 17; 
end
else
begin
  sym := _noSym;
exit;
end;
  10: if (CurrInputCh = CHR(39)) then
begin
state := 7; 
end
else
begin
sym := SQLStringSym;
exit;
end;
  11: begin
sym := _semicolonSym;
exit;
end;
  12: begin
sym := _equalSym;
exit;
end;
  13: begin
sym := _rbrackSym;
exit;
end;
  14: if (CurrInputCh = ']') then
begin
state := 15; 
end
else
begin
  sym := _noSym;
exit;
end;
  15: begin
sym := _lbrack_star_rbrackSym;
exit;
end;
  16: begin
sym := _starSym;
exit;
end;
  17: begin
sym := _point_starSym;
exit;
end;
  18: begin
sym := _minusSym;
exit;
end;
  19: begin
sym := _colonSym;
exit;
end;
  20: begin
sym := _slashSym;
exit;
end;
  21: begin
sym := _plusSym;
exit;
end;
  22: if (CurrInputCh = '>') then
begin
state := 23; 
end
else if (CurrInputCh = '=') then
begin
state := 24; 
end
else
begin
sym := _lessSym;
exit;
end;
  23: begin
sym := _less_greaterSym;
exit;
end;
  24: begin
sym := _less_equalSym;
exit;
end;
  25: if (CurrInputCh = '=') then
begin
state := 26; 
end
else
begin
sym := _greaterSym;
exit;
end;
  26: begin
sym := _greater_equalSym;
exit;
end;
  27: begin
sym := _commaSym;
exit;
end;
  28: begin
sym := _lparenSym;
exit;
end;
  29: begin
sym := _rparenSym;
exit;
end;
  30: begin
sym := EOFSYMB;
CurrInputCh := chNull;
BufferPosition := BufferPosition - 1;
exit
end;
    else
      begin
        sym := _noSym;
        EXIT;          // NextCh already done
      end;
    end;
  end;
end;  {Get}

constructor TovOQLGrammarScanner.Create;
begin
  inherited;
fHashList := TmwStringHashList.Create(ITinyHash, HashSecondaryOne, SameText);
fHashList.AddString('ALL', ALLSym, ALLSym);
fHashList.AddString('AND', ANDSym, ANDSym);
fHashList.AddString('AS', ASSym, ASSym);
fHashList.AddString('ASC', ASCSym, ASCSym);
fHashList.AddString('AVG', AVGSym, AVGSym);
fHashList.AddString('BETWEEN', BETWEENSym, BETWEENSym);
fHashList.AddString('BY', BYSym, BYSym);
fHashList.AddString('COUNT', COUNTSym, COUNTSym);
fHashList.AddString('DELETE', DELETESym, DELETESym);
fHashList.AddString('DESC', DESCSym, DESCSym);
fHashList.AddString('DISTINCT', DISTINCTSym, DISTINCTSym);
fHashList.AddString('ESCAPE', ESCAPESym, ESCAPESym);
fHashList.AddString('EXISTING', EXISTINGSym, EXISTINGSym);
fHashList.AddString('FETCH', FETCHSym, FETCHSym);
fHashList.AddString('FROM', FROMSym, FROMSym);
fHashList.AddString('GROUP', GROUPSym, GROUPSym);
fHashList.AddString('HAVING', HAVINGSym, HAVINGSym);
fHashList.AddString('IN', INSym, INSym);
fHashList.AddString('INSERT', INSERTSym, INSERTSym);
fHashList.AddString('INTO', INTOSym, INTOSym);
fHashList.AddString('IS', ISSym, ISSym);
fHashList.AddString('LIKE', LIKESym, LIKESym);
fHashList.AddString('MAX', MAXSym, MAXSym);
fHashList.AddString('MIN', MINSym, MINSym);
fHashList.AddString('MONTH', MONTHSym, MONTHSym);
fHashList.AddString('NOT', NOTSym, NOTSym);
fHashList.AddString('NULL', NULLSym, NULLSym);
fHashList.AddString('OR', ORSym, ORSym);
fHashList.AddString('ORDER', ORDERSym, ORDERSym);
fHashList.AddString('SELECT', SELECTSym, SELECTSym);
fHashList.AddString('SET', SETSym, SETSym);
fHashList.AddString('SUM', SUMSym, SUMSym);
fHashList.AddString('TIMESTAMP', TIMESTAMPSym, TIMESTAMPSym);
fHashList.AddString('UNION', UNIONSym, UNIONSym);
fHashList.AddString('UPDATE', UPDATESym, UPDATESym);
fHashList.AddString('UPPER', UPPERSym, UPPERSym);
fHashList.AddString('VALUES', VALUESSym, VALUESSym);
fHashList.AddString('WHERE', WHERESym, WHERESym);
fHashList.AddString('WITH', WITHSym, WITHSym);
fHashList.AddString('YEAR', YEARSym, YEARSym);
CurrentCh := CapChAt;
fStartState[  0] := 30; fStartState[  1] := 31; fStartState[  2] := 31; fStartState[  3] := 31; 
fStartState[  4] := 31; fStartState[  5] := 31; fStartState[  6] := 31; fStartState[  7] := 31; 
fStartState[  8] := 31; fStartState[  9] := 31; fStartState[ 10] := 31; fStartState[ 11] := 31; 
fStartState[ 12] := 31; fStartState[ 13] := 31; fStartState[ 14] := 31; fStartState[ 15] := 31; 
fStartState[ 16] := 31; fStartState[ 17] := 31; fStartState[ 18] := 31; fStartState[ 19] := 31; 
fStartState[ 20] := 31; fStartState[ 21] := 31; fStartState[ 22] := 31; fStartState[ 23] := 31; 
fStartState[ 24] := 31; fStartState[ 25] := 31; fStartState[ 26] := 31; fStartState[ 27] := 31; 
fStartState[ 28] := 31; fStartState[ 29] := 31; fStartState[ 30] := 31; fStartState[ 31] := 31; 
fStartState[ 32] := 31; fStartState[ 33] :=  1; fStartState[ 34] := 31; fStartState[ 35] :=  1; 
fStartState[ 36] :=  1; fStartState[ 37] := 31; fStartState[ 38] := 31; fStartState[ 39] :=  7; 
fStartState[ 40] := 28; fStartState[ 41] := 29; fStartState[ 42] := 16; fStartState[ 43] := 21; 
fStartState[ 44] := 27; fStartState[ 45] := 18; fStartState[ 46] :=  9; fStartState[ 47] := 20; 
fStartState[ 48] :=  8; fStartState[ 49] :=  8; fStartState[ 50] :=  8; fStartState[ 51] :=  8; 
fStartState[ 52] :=  8; fStartState[ 53] :=  8; fStartState[ 54] :=  8; fStartState[ 55] :=  8; 
fStartState[ 56] :=  8; fStartState[ 57] :=  8; fStartState[ 58] := 19; fStartState[ 59] := 11; 
fStartState[ 60] := 22; fStartState[ 61] := 12; fStartState[ 62] := 25; fStartState[ 63] := 31; 
fStartState[ 64] :=  1; fStartState[ 65] :=  1; fStartState[ 66] :=  1; fStartState[ 67] :=  1; 
fStartState[ 68] :=  1; fStartState[ 69] :=  1; fStartState[ 70] :=  1; fStartState[ 71] :=  1; 
fStartState[ 72] :=  1; fStartState[ 73] :=  1; fStartState[ 74] :=  1; fStartState[ 75] :=  1; 
fStartState[ 76] :=  1; fStartState[ 77] :=  1; fStartState[ 78] :=  1; fStartState[ 79] :=  1; 
fStartState[ 80] :=  1; fStartState[ 81] :=  1; fStartState[ 82] :=  1; fStartState[ 83] :=  1; 
fStartState[ 84] :=  1; fStartState[ 85] :=  1; fStartState[ 86] :=  1; fStartState[ 87] :=  1; 
fStartState[ 88] :=  1; fStartState[ 89] :=  1; fStartState[ 90] :=  1; fStartState[ 91] :=  2; 
fStartState[ 92] :=  1; fStartState[ 93] := 13; fStartState[ 94] :=  1; fStartState[ 95] :=  1; 
fStartState[ 96] :=  1; fStartState[ 97] :=  1; fStartState[ 98] :=  1; fStartState[ 99] :=  1; 
fStartState[100] :=  1; fStartState[101] :=  1; fStartState[102] :=  1; fStartState[103] :=  1; 
fStartState[104] :=  1; fStartState[105] :=  1; fStartState[106] :=  1; fStartState[107] :=  1; 
fStartState[108] :=  1; fStartState[109] :=  1; fStartState[110] :=  1; fStartState[111] :=  1; 
fStartState[112] :=  1; fStartState[113] :=  1; fStartState[114] :=  1; fStartState[115] :=  1; 
fStartState[116] :=  1; fStartState[117] :=  1; fStartState[118] :=  1; fStartState[119] :=  1; 
fStartState[120] :=  1; fStartState[121] :=  1; fStartState[122] :=  1; fStartState[123] :=  1; 
fStartState[124] := 31; fStartState[125] :=  1; fStartState[126] :=  1; fStartState[127] :=  1; 
fStartState[128] :=  1; fStartState[129] :=  1; fStartState[130] :=  1; fStartState[131] :=  1; 
fStartState[132] :=  1; fStartState[133] :=  1; fStartState[134] :=  1; fStartState[135] :=  1; 
fStartState[136] :=  1; fStartState[137] :=  1; fStartState[138] :=  1; fStartState[139] :=  1; 
fStartState[140] :=  1; fStartState[141] :=  1; fStartState[142] :=  1; fStartState[143] :=  1; 
fStartState[144] :=  1; fStartState[145] :=  1; fStartState[146] :=  1; fStartState[147] :=  1; 
fStartState[148] :=  1; fStartState[149] :=  1; fStartState[150] :=  1; fStartState[151] :=  1; 
fStartState[152] :=  1; fStartState[153] :=  1; fStartState[154] :=  1; fStartState[155] :=  1; 
fStartState[156] :=  1; fStartState[157] :=  1; fStartState[158] :=  1; fStartState[159] :=  1; 
fStartState[160] :=  1; fStartState[161] :=  1; fStartState[162] :=  1; fStartState[163] :=  1; 
fStartState[164] :=  1; fStartState[165] :=  1; fStartState[166] :=  1; fStartState[167] :=  1; 
fStartState[168] :=  1; fStartState[169] :=  1; fStartState[170] :=  1; fStartState[171] :=  1; 
fStartState[172] :=  1; fStartState[173] :=  1; fStartState[174] :=  1; fStartState[175] :=  1; 
fStartState[176] :=  1; fStartState[177] :=  1; fStartState[178] :=  1; fStartState[179] :=  1; 
fStartState[180] :=  1; fStartState[181] :=  1; fStartState[182] :=  1; fStartState[183] :=  1; 
fStartState[184] :=  1; fStartState[185] :=  1; fStartState[186] :=  1; fStartState[187] :=  1; 
fStartState[188] :=  1; fStartState[189] :=  1; fStartState[190] :=  1; fStartState[191] :=  1; 
fStartState[192] :=  1; fStartState[193] :=  1; fStartState[194] :=  1; fStartState[195] :=  1; 
fStartState[196] :=  1; fStartState[197] :=  1; fStartState[198] :=  1; fStartState[199] :=  1; 
fStartState[200] :=  1; fStartState[201] :=  1; fStartState[202] :=  1; fStartState[203] :=  1; 
fStartState[204] :=  1; fStartState[205] :=  1; fStartState[206] :=  1; fStartState[207] :=  1; 
fStartState[208] :=  1; fStartState[209] :=  1; fStartState[210] :=  1; fStartState[211] :=  1; 
fStartState[212] :=  1; fStartState[213] :=  1; fStartState[214] :=  1; fStartState[215] :=  1; 
fStartState[216] :=  1; fStartState[217] :=  1; fStartState[218] :=  1; fStartState[219] :=  1; 
fStartState[220] :=  1; fStartState[221] :=  1; fStartState[222] :=  1; fStartState[223] :=  1; 
fStartState[224] :=  1; fStartState[225] :=  1; fStartState[226] :=  1; fStartState[227] :=  1; 
fStartState[228] :=  1; fStartState[229] :=  1; fStartState[230] :=  1; fStartState[231] :=  1; 
fStartState[232] :=  1; fStartState[233] :=  1; fStartState[234] :=  1; fStartState[235] :=  1; 
fStartState[236] :=  1; fStartState[237] :=  1; fStartState[238] :=  1; fStartState[239] :=  1; 
fStartState[240] :=  1; fStartState[241] :=  1; fStartState[242] :=  1; fStartState[243] :=  1; 
fStartState[244] :=  1; fStartState[245] :=  1; fStartState[246] :=  1; fStartState[247] :=  1; 
fStartState[248] :=  1; fStartState[249] :=  1; fStartState[250] :=  1; fStartState[251] :=  1; 
fStartState[252] :=  1; fStartState[253] :=  1; fStartState[254] :=  1; fStartState[255] :=  1; 
end; {Create}

destructor TovOQLGrammarScanner.Destroy;
begin
  fHashList.Free;
  fHashList := NIL;
  inherited;
end;

{ --------------------------------------------------------------------------- }
{ ---- implementation for TovOQLGrammar ---- }

constructor TovOQLGrammar.Create(AOwner : TComponent);
begin
  inherited;
  Scanner := TovOQLGrammarScanner.Create;
  GetScanner.Owner := self;
FSelectStatements := TObjectList.Create;

  InitSymSet;
end; {Create}

destructor TovOQLGrammar.Destroy;
begin
  Scanner.Free;
FSelectStatements.Free;

  inherited;
end; {Destroy}

function TovOQLGrammar.ErrorStr(const ErrorCode : integer; const Data : string) : string;
begin
  case ErrorCode of
       0 : Result := 'EOF expected';
   1 : Result := 'ident expected';
   2 : Result := 'IdentWithLBracket expected';
   3 : Result := 'NextIdent expected';
   4 : Result := 'integer_ expected';
   5 : Result := 'float expected';
   6 : Result := 'SQLString expected';
   7 : Result := '";" expected';
   8 : Result := '"UNION" expected';
   9 : Result := '"ALL" expected';
  10 : Result := '"UPDATE" expected';
  11 : Result := '"SET" expected';
  12 : Result := '"=" expected';
  13 : Result := '"INSERT" expected';
  14 : Result := '"INTO" expected';
  15 : Result := '"VALUES" expected';
  16 : Result := '"DELETE" expected';
  17 : Result := '"FROM" expected';
  18 : Result := '"SELECT" expected';
  19 : Result := '"DISTINCT" expected';
  20 : Result := '"FETCH" expected';
  21 : Result := '"]" expected';
  22 : Result := '"EXISTING" expected';
  23 : Result := '"WITH" expected';
  24 : Result := '"AS" expected';
  25 : Result := '"WHERE" expected';
  26 : Result := '"HAVING" expected';
  27 : Result := '"ORDER" expected';
  28 : Result := '"BY" expected';
  29 : Result := '"GROUP" expected';
  30 : Result := '"[*]" expected';
  31 : Result := '"TIMESTAMP" expected';
  32 : Result := '"UPPER" expected';
  33 : Result := '"MONTH" expected';
  34 : Result := '"YEAR" expected';
  35 : Result := '"COUNT" expected';
  36 : Result := '"SUM" expected';
  37 : Result := '"MAX" expected';
  38 : Result := '"MIN" expected';
  39 : Result := '"AVG" expected';
  40 : Result := '"*" expected';
  41 : Result := '".*" expected';
  42 : Result := '"NULL" expected';
  43 : Result := '"DESC" expected';
  44 : Result := '"ASC" expected';
  45 : Result := '"-" expected';
  46 : Result := '":" expected';
  47 : Result := '"NOT" expected';
  48 : Result := '"/" expected';
  49 : Result := '"+" expected';
  50 : Result := '"AND" expected';
  51 : Result := '"OR" expected';
  52 : Result := '"LIKE" expected';
  53 : Result := '"ESCAPE" expected';
  54 : Result := '"IS" expected';
  55 : Result := '"<>" expected';
  56 : Result := '"<" expected';
  57 : Result := '"<=" expected';
  58 : Result := '">" expected';
  59 : Result := '">=" expected';
  60 : Result := '"BETWEEN" expected';
  61 : Result := '"IN" expected';
  62 : Result := '"," expected';
  63 : Result := '"(" expected';
  64 : Result := '")" expected';
  65 : Result := 'not expected';
  66 : Result := 'invalid InSetExpr';
  67 : Result := 'invalid LikeTest';
  68 : Result := 'invalid WordOperator';
  69 : Result := 'invalid MathOperator';
  70 : Result := 'invalid TestExpr';
  71 : Result := 'invalid TestExpr';
  72 : Result := 'invalid Operator';
  73 : Result := 'invalid Term';
  74 : Result := 'invalid Term';
  75 : Result := 'invalid Relation';
  76 : Result := 'invalid Field';
  77 : Result := 'invalid ColumnFunction';
  78 : Result := 'invalid ColumnFunction';
  79 : Result := 'invalid FunctionExpr';
  80 : Result := 'invalid SelectField';
  81 : Result := 'this symbol not expected in OrderByClause';
  82 : Result := 'this symbol not expected in HavingClause';
  83 : Result := 'this symbol not expected in GroupByClause';
  84 : Result := 'this symbol not expected in FetchClause';
  85 : Result := 'this symbol not expected in FromClause';
  86 : Result := 'this symbol not expected in WhereClause';
  87 : Result := 'invalid InsertStmt';
  88 : Result := 'invalid ovOQLGrammar';

200 : Result := 'Unexpected end of command';
    201 : Result := '"ON" or "USING" clause may not be used with "NATURAL"';
    202 : Result := '"UNION JOIN" not supported';
    203 : Result := '"NULL" keyword cannot be used here - use "IS" or "IS NOT"';
  else
    if Assigned(OnCustomError) then
      Result := OnCustomError(Self, ErrorCode, Data)
    else
    begin
      Result := 'Error: ' + IntToStr(ErrorCode);
      if Trim(Data) > '' then
        Result := Result + ' (' + Data + ')';
    end;
  end;  {case nr}
end; {ErrorStr}

procedure TovOQLGrammar.Execute;
begin
  ClearErrors;
  ListStream.Clear;
  Extra := 1;

  { if there is a file name then load the file }
  if Trim(SourceFileName) <> '' then
  begin
    GetScanner.SrcStream.Clear;
    GetScanner.SrcStream.LoadFromFile(SourceFileName);
  end;

  { install error reporting procedure }
  GetScanner.ScannerError := StoreError;

  { instigate the compilation }
  DoBeforeParse;
  Parse;
  DoAfterParse;

  { generate the source listing to the ListStream }
  if (GenListWhen = glAlways) OR ((GenListWhen = glOnError) AND (ErrorList.Count > 0)) then
    GenerateListing;
  if ClearSourceStream then
    GetScanner.SrcStream.Clear;
  ListStream.Position := 0;  // goto the beginning of the stream
  if Successful AND Assigned(OnSuccess) then
    OnSuccess(Self);
  if (NOT Successful) AND Assigned(OnFailure) then
    OnFailure(Self, ErrorList.Count);
end;  {Execute}

procedure TovOQLGrammar.Get;
begin
  repeat


    GetScanner.Get(fCurrentInputSymbol);
    if fCurrentInputSymbol <= maxT then
      errDist := errDist + 1
    else
    begin
    end;
  until fCurrentInputSymbol <= maxT;
  if Assigned(AfterGet) then
    AfterGet(Self, fCurrentInputSymbol);
end;  {Get}

function TovOQLGrammar.GetScanner : TovOQLGrammarScanner;
begin
  Result := Scanner AS TovOQLGrammarScanner;
end; {GetScanner}

function TovOQLGrammar._In(var s : SymbolSet; x : integer) : boolean;
begin
  _In := x mod setsize in s[x div setsize];
end;  {_In}

procedure TovOQLGrammar.ExpectWeak(n, follow : integer);
begin
  if fCurrentInputSymbol = n then
    Get
  else
  begin
    SynError(n);
    while (fCurrentInputSymbol > EOFSYMB) AND (not _In(symSet[follow], fCurrentInputSymbol)) do
      Get;
  end
end;  {ExpectWeak}

function TovOQLGrammar.WeakSeparator(n, syFol, repFol : integer) : boolean;
var
  s : SymbolSet;
  i : integer;
begin
  if fCurrentInputSymbol = n then
  begin
    Get;
    Result := true;
    exit;
  end
  else if _In(symSet[repFol], fCurrentInputSymbol) then
  begin
    Result := false;
    exit;
  end
  else
  begin
    i := 0;
    while i <= maxT div setsize do
    begin
      s[i] := symSet[0, i] + symSet[syFol, i] + symSet[repFol, i];
      inc(i)
    end;
    SynError(n);
    while not _In(s, fCurrentInputSymbol) do
      Get;
    Result := _In(symSet[syFol], fCurrentInputSymbol)
  end
end;  {WeakSeparator}

procedure TovOQLGrammar._BetweenExpr;begin
Expect(BETWEENSym);
_Field;
Expect(ANDSym);
_Field;
end;

procedure TovOQLGrammar._InSetExpr;begin
Expect(INSym);
AddToken(ttInSetOperator);
_OpenParens;
if _In(symSet[1], fCurrentInputSymbol) then begin
_FieldList;
end else if (fCurrentInputSymbol = SELECTSym) then begin
_SubSelectSQL;
end else begin SynError(66);
end;
_CloseParens;
end;

procedure TovOQLGrammar._NullTest;begin
Expect(ISSym);
AddToken(ttIsOperator);
if (fCurrentInputSymbol = NOTSym) then begin
_NotOperator;
end;
_Null;
AddToken(ttNull);
end;

procedure TovOQLGrammar._LikeTest;begin
Expect(LIKESym);
AddToken(ttStringOperator);
if (fCurrentInputSymbol = SQLStringSym) then begin
Get;
AddToken(ttString);
end else if (fCurrentInputSymbol = _colonSym) then begin
_Param;
end else begin SynError(67);
end;
if (fCurrentInputSymbol = ESCAPESym) then begin
Get;
WriteKeyword;
Expect(SQLStringSym);
WriteType('String:');
end;
end;

procedure TovOQLGrammar._WordOperator;begin
if (fCurrentInputSymbol = ANDSym) then begin
Get;
end else if (fCurrentInputSymbol = ORSym) then begin
Get;
end else begin SynError(68);
end;
AddToken(ttLogicalOperator)
end;

procedure TovOQLGrammar._MathOperator;begin
if (fCurrentInputSymbol = _starSym) then begin
Get;
end else if (fCurrentInputSymbol = _slashSym) then begin
Get;
end else if (fCurrentInputSymbol = _plusSym) then begin
Get;
end else if (fCurrentInputSymbol = _minusSym) then begin
Get;
end else begin SynError(69);
end;
AddToken(ttMathOperator)
end;

procedure TovOQLGrammar._TestExpr;begin
if (fCurrentInputSymbol = ISSym) then begin
_NullTest;
end else if (fCurrentInputSymbol = NOTSym) OR
 (fCurrentInputSymbol = LIKESym) OR
 (fCurrentInputSymbol = BETWEENSym) OR
 (fCurrentInputSymbol = INSym) then begin
if (fCurrentInputSymbol = NOTSym) then begin
_NotOperator;
end;
if (fCurrentInputSymbol = INSym) then begin
_InSetExpr;
end else if (fCurrentInputSymbol = BETWEENSym) then begin
_BetweenExpr;
end else if (fCurrentInputSymbol = LIKESym) then begin
_LikeTest;
end else begin SynError(70);
end;
end else begin SynError(71);
end;
end;

procedure TovOQLGrammar._Operator;begin
if (fCurrentInputSymbol = _starSym) OR
 (fCurrentInputSymbol = _minusSym) OR
 (fCurrentInputSymbol = _slashSym) OR
 (fCurrentInputSymbol = _plusSym) then begin
_MathOperator;
end else if (fCurrentInputSymbol = ANDSym) OR
 (fCurrentInputSymbol = ORSym) then begin
_WordOperator;
end else begin SynError(72);
end;
end;

procedure TovOQLGrammar._Term;begin
if (fCurrentInputSymbol = _minusSym) then begin
Get;
AddToken(ttMathOperator)
end;
if _In(symSet[1], fCurrentInputSymbol) then begin
_Field;
if (fCurrentInputSymbol = NOTSym) OR
 (fCurrentInputSymbol = LIKESym) OR
 (fCurrentInputSymbol = ISSym) OR
 (fCurrentInputSymbol = BETWEENSym) OR
 (fCurrentInputSymbol = INSym) then begin
_TestExpr;
end;
end else if (fCurrentInputSymbol = COUNTSym) OR
 (fCurrentInputSymbol = SUMSym) OR
 (fCurrentInputSymbol = MAXSym) OR
 (fCurrentInputSymbol = MINSym) OR
 (fCurrentInputSymbol = AVGSym) then begin
_ColumnFunction;
end else if (fCurrentInputSymbol = TIMESTAMPSym) OR
 (fCurrentInputSymbol = UPPERSym) OR
 (fCurrentInputSymbol = MONTHSym) OR
 (fCurrentInputSymbol = YEARSym) then begin
_FunctionExpr;
end else if (fCurrentInputSymbol = _lparenSym) then begin
_OpenParens;
if _In(symSet[2], fCurrentInputSymbol) then begin
_Expression;
end else if (fCurrentInputSymbol = SELECTSym) then begin
_SubSelectSQL;
end else begin SynError(73);
end;
_CloseParens;
end else begin SynError(74);
end;
end;

procedure TovOQLGrammar._NotOperator;begin
Expect(NOTSym);
AddToken(ttLogicalOperator)
end;

procedure TovOQLGrammar._Relation;begin
case fCurrentInputSymbol of
  _equalSym : begin
Get;
    end;
  _less_greaterSym : begin
Get;
    end;
  _lessSym : begin
Get;
    end;
  _less_equalSym : begin
Get;
    end;
  _greaterSym : begin
Get;
    end;
  _greater_equalSym : begin
Get;
    end;
else begin SynError(75);
    end;
end;
AddToken(ttRelation);
if  LookAheadName  =  'NULL'  then
   SynError(203);
end;

procedure TovOQLGrammar._SimpleExpression;begin
if (fCurrentInputSymbol = NOTSym) then begin
_NotOperator;
end;
_Term;
while _In(symSet[3], fCurrentInputSymbol) do begin
_Operator;
if (fCurrentInputSymbol = NOTSym) then begin
_NotOperator;
end;
_Term;
end;
end;

procedure TovOQLGrammar._OrderByField;begin
_ColumnName;
if (fCurrentInputSymbol = DESCSym) OR
 (fCurrentInputSymbol = ASCSym) then begin
if (fCurrentInputSymbol = DESCSym) then begin
Get;
AddKeyWord(ttSortOrder);
end else begin
Get;
AddKeyWord(ttSortOrder);
end;
end;
end;

procedure TovOQLGrammar._Param;begin
Expect(_colonSym);
Expect(identSym);
AddToken(ttParam);
end;

procedure TovOQLGrammar._Null;begin
Expect(NULLSym);
WriteType('NULL:');
end;

procedure TovOQLGrammar._Field;begin
case fCurrentInputSymbol of
  IdentWithLBracketSym : begin
_ColumnName;
    end;
  NULLSym : begin
_Null;
    end;
  floatSym : begin
Get;
AddToken(ttFloat);
    end;
  integer_Sym : begin
Get;
AddToken(ttInteger);
    end;
  SQLStringSym : begin
Get;
AddToken(ttString);
    end;
  _colonSym : begin
_Param;
    end;
else begin SynError(76);
    end;
end;
end;

procedure TovOQLGrammar._ColumnFunction;begin
if (fCurrentInputSymbol = COUNTSym) then begin
Get;
end else if (fCurrentInputSymbol = SUMSym) then begin
Get;
end else if (fCurrentInputSymbol = MAXSym) then begin
Get;
end else if (fCurrentInputSymbol = MINSym) then begin
Get;
end else if (fCurrentInputSymbol = AVGSym) then begin
Get;
end else begin SynError(77);
end;
AddToken(ttColumnFunc);
_OpenParens;
if (fCurrentInputSymbol = _starSym) then begin
Get;
WriteType('All  Columns:');
end else if _In(symSet[4], fCurrentInputSymbol) then begin
if (fCurrentInputSymbol = DISTINCTSym) then begin
Get;
WriteKeyword;
end;
_Expression;
end else begin SynError(78);
end;
_CloseParens;
end;

procedure TovOQLGrammar._FunctionExpr;begin
if (fCurrentInputSymbol = TIMESTAMPSym) then begin
Get;
end else if (fCurrentInputSymbol = UPPERSym) then begin
Get;
end else if (fCurrentInputSymbol = MONTHSym) then begin
Get;
end else if (fCurrentInputSymbol = YEARSym) then begin
Get;
end else begin SynError(79);
end;
WriteType('Function');
_OpenParens;
_Expression;
while (fCurrentInputSymbol = _commaSym) do begin
_ItemSeparator;
_Expression;
end;
_CloseParens;
end;

procedure TovOQLGrammar._SelectField;begin
if _In(symSet[2], fCurrentInputSymbol) then begin
_Expression;
if (fCurrentInputSymbol = ASSym) then begin
Get;
_Alias;
AddToken(ttFieldAlias);
end;
end else if (fCurrentInputSymbol = _lbrack_star_rbrackSym) then begin
Get;
AddToken(Copy(LexString,  2,  Length(LexString)-2),  ttSelectAll);
end else begin SynError(80);
end;
end;

procedure TovOQLGrammar._OrderByFldList;begin
_OrderByField;
while (fCurrentInputSymbol = _commaSym) do begin
_ItemSeparator;
_OrderByField;
end;
end;

procedure TovOQLGrammar._Alias;begin
Expect(identSym);
end;

procedure TovOQLGrammar._QualifiedTable;begin
Expect(IdentWithLBracketSym);
AddToken(Copy(LexString,  2,  Length(LexString)),  ttClassName);
Expect(_rbrackSym);
if (fCurrentInputSymbol = identSym) OR
 (fCurrentInputSymbol = ASSym) then begin
if (fCurrentInputSymbol = ASSym) then begin
Get;
end;
_Alias;
AddToken(ttClassAlias);
end;
end;

procedure TovOQLGrammar._SearchCondition;begin
_Expression;
end;

procedure TovOQLGrammar._FetchRelationList;begin
Expect(IdentWithLBracketSym);
AddToken(Copy(LexString,  2,  Length(LexString)),  ttIdent);
while (fCurrentInputSymbol = NextIdentSym) do begin
Get;
AddToken(Copy(LexString,  2,  Length(LexString)),  ttIdent);
end;
Expect(_rbrackSym);
if (fCurrentInputSymbol = ALLSym) OR
 (fCurrentInputSymbol = EXISTINGSym) then begin
if (fCurrentInputSymbol = ALLSym) then begin
Get;
AddKeyword(ttFetchAll);
end else begin
Get;
AddKeyword(ttFetchExisting);
end;
end;
if (fCurrentInputSymbol = WITHSym) then begin
Get;
AddToken(ttFetchCondition);
_SearchCondition;
end;
end;

procedure TovOQLGrammar._FromTableList;begin
_QualifiedTable;
while (fCurrentInputSymbol = _commaSym) do begin
_ItemSeparator;
_QualifiedTable;
end;
end;

procedure TovOQLGrammar._SelectFieldList;begin
_SelectField;
while (fCurrentInputSymbol = _commaSym) do begin
_ItemSeparator;
_SelectField;
end;
end;

procedure TovOQLGrammar._OrderByClause;begin
while not ( (fCurrentInputSymbol = EOFSYMB) OR
 (fCurrentInputSymbol = ORDERSym)) do begin SynError(81); Get; end;
Expect(ORDERSym);
Expect(BYSym);
_OrderByFldList;
end;

procedure TovOQLGrammar._HavingClause;begin
while not ( (fCurrentInputSymbol = EOFSYMB) OR
 (fCurrentInputSymbol = HAVINGSym)) do begin SynError(82); Get; end;
Expect(HAVINGSym);
_SearchCondition;
end;

procedure TovOQLGrammar._GroupByClause;begin
while not ( (fCurrentInputSymbol = EOFSYMB) OR
 (fCurrentInputSymbol = GROUPSym)) do begin SynError(83); Get; end;
Expect(GROUPSym);
Expect(BYSym);
_FieldList;
end;

procedure TovOQLGrammar._FetchClause;begin
while not ( (fCurrentInputSymbol = EOFSYMB) OR
 (fCurrentInputSymbol = FETCHSym)) do begin SynError(84); Get; end;
Expect(FETCHSym);
_FetchRelationList;
while (fCurrentInputSymbol = _commaSym) do begin
_ItemSeparator;
_FetchRelationList;
end;
end;

procedure TovOQLGrammar._FromClause;begin
while not ( (fCurrentInputSymbol = EOFSYMB) OR
 (fCurrentInputSymbol = FROMSym)) do begin SynError(85); Get; end;
Expect(FROMSym);
_FromTableList;
end;

procedure TovOQLGrammar._SelectClause;begin
Expect(SELECTSym);
if (fCurrentInputSymbol = ALLSym) OR
 (fCurrentInputSymbol = DISTINCTSym) then begin
if (fCurrentInputSymbol = DISTINCTSym) then begin
Get;
AddKeyword(ttDistinct);
end else begin
Get;
end;
end;
_SelectFieldList;
end;

procedure TovOQLGrammar._FieldList;begin
_Field;
while (fCurrentInputSymbol = _commaSym) do begin
_ItemSeparator;
_Field;
end;
end;

procedure TovOQLGrammar._CloseParens;begin
ExpectWeak(_rparenSym, 5);
AddToken(ttRBracket);
end;

procedure TovOQLGrammar._ColumnList;begin
_ColumnName;
while (fCurrentInputSymbol = _commaSym) do begin
_ItemSeparator;
_ColumnName;
end;
end;

procedure TovOQLGrammar._OpenParens;begin
Expect(_lparenSym);
AddToken(ttLBracket);
end;

procedure TovOQLGrammar._ItemSeparator;begin
ExpectWeak(_commaSym, 6);
AddToken(ttComma);
end;

procedure TovOQLGrammar._Expression;begin
_SimpleExpression;
while _In(symSet[7], fCurrentInputSymbol) do begin
_Relation;
_SimpleExpression;
end;
end;

procedure TovOQLGrammar._ColumnName;begin
Expect(IdentWithLBracketSym);
AddToken(Copy(LexString,  2,  Length(LexString)),  ttIdent);
while (fCurrentInputSymbol = NextIdentSym) OR
 (fCurrentInputSymbol = _point_starSym) do begin
if (fCurrentInputSymbol = NextIdentSym) then begin
Get;
AddToken(Copy(LexString,  2,  Length(LexString)),  ttIdent);
end else begin
Get;
AddToken('*',  ttSelectAll);
end;
end;
Expect(_rbrackSym);
end;

procedure TovOQLGrammar._UpdateField;begin
_ColumnName;
Expect(_equalSym);
_Expression;
end;

procedure TovOQLGrammar._WhereClause;begin
while not ( (fCurrentInputSymbol = EOFSYMB) OR
 (fCurrentInputSymbol = WHERESym)) do begin SynError(86); Get; end;
Expect(WHERESym);
_SearchCondition;
end;

procedure TovOQLGrammar._UpdateFieldList;begin
_UpdateField;
while (fCurrentInputSymbol = _commaSym) do begin
_ItemSeparator;
_UpdateField;
end;
end;

procedure TovOQLGrammar._Table;begin
Expect(IdentWithLBracketSym);
Expect(_rbrackSym);
WriteType('Table:');
end;

procedure TovOQLGrammar._DeleteStmt;begin
Expect(DELETESym);
WriteKeyword;
Expect(FROMSym);
WriteKeyword;
_Table;
if (fCurrentInputSymbol = WHERESym) then begin
_WhereClause;
end;
end;

procedure TovOQLGrammar._InsertStmt;begin
Expect(INSERTSym);
WriteKeyword;
Expect(INTOSym);
WriteKeyword;
_Table;
if (fCurrentInputSymbol = _lparenSym) then begin
_OpenParens;
_ColumnList;
_CloseParens;
end;
if (fCurrentInputSymbol = VALUESSym) then begin
Get;
WriteKeyword;
_OpenParens;
_FieldList;
_CloseParens;
end else if (fCurrentInputSymbol = SELECTSym) then begin
_SelectSQL;
end else begin SynError(87);
end;
end;

procedure TovOQLGrammar._UpdateStmt;begin
Expect(UPDATESym);
_Table;
Expect(SETSym);
_UpdateFieldList;
if (fCurrentInputSymbol = WHERESym) then begin
_WhereClause;
end;
end;

procedure TovOQLGrammar._SubSelectSQL;var
   SaveCurrentExpression:  TQueryStatementExpression;
   SaveCurrentSelectStatement:  TSelectStatement;
begin
SaveCurrentSelectStatement  :=  FSelectStatement;
SaveCurrentExpression  :=  FCurrentExpression;
AddToken(IntToStr(FSelectStatements.Count),  ttSubSelect);
_SelectSQL;
FSelectStatement  :=  SaveCurrentSelectStatement;
FCurrentExpression  :=  SaveCurrentExpression;
end;

procedure TovOQLGrammar._SelectStmt;begin
FSelectStatement  :=  NewSelectStatement;
FCurrentExpression  :=  FSelectStatement.SelectExpression;
_SelectClause;
FCurrentExpression  :=  FSelectStatement.FromExpression;
_FromClause;
FCurrentExpression  :=  FSelectStatement.FetchExpression;
if (fCurrentInputSymbol = FETCHSym) then begin
_FetchClause;
end;
FCurrentExpression  :=  FSelectStatement.WhereExpression;
if (fCurrentInputSymbol = WHERESym) then begin
_WhereClause;
end;
FCurrentExpression  :=  FSelectStatement.GroupByExpression;
if (fCurrentInputSymbol = GROUPSym) then begin
_GroupByClause;
end;
FCurrentExpression  :=  FSelectStatement.HavingExpression;
if (fCurrentInputSymbol = HAVINGSym) then begin
_HavingClause;
end;
FCurrentExpression  :=  FSelectStatement.OrderByExpression;
if (fCurrentInputSymbol = ORDERSym) then begin
_OrderByClause;
end;
FCurrentExpression  :=  FSelectStatement.UnionExpression;
end;

procedure TovOQLGrammar._DeleteSQL;begin
_DeleteStmt;
end;

procedure TovOQLGrammar._InsertSQL;begin
_InsertStmt;
end;

procedure TovOQLGrammar._UpdateSQL;begin
_UpdateStmt;
end;

procedure TovOQLGrammar._SelectSQL;begin
_SelectStmt;
while (fCurrentInputSymbol = UNIONSym) do begin
Get;
if (fCurrentInputSymbol = ALLSym) then begin
Get;
AddKeyword(ttUnionAll);
end;
AddToken(IntToStr(FSelectStatements.Count),  ttSubSelect);
_SelectStmt;
end;
end;

procedure TovOQLGrammar._ovOQLGrammar;begin
Init;
if (fCurrentInputSymbol = SELECTSym) then begin
_SelectSQL;
end else if (fCurrentInputSymbol = UPDATESym) then begin
_UpdateSQL;
end else if (fCurrentInputSymbol = INSERTSym) then begin
_InsertSQL;
end else if (fCurrentInputSymbol = DELETESym) then begin
_DeleteSQL;
end else begin SynError(88);
end;
if (fCurrentInputSymbol = _semicolonSym) then begin
Get;
end;
if  fCurrentInputSymbol  <>  EOFSYMB  then
   SynError(200);
Final;
end;

function TovOQLGrammar.GetBuildDate : TDateTime;
const
  BDate = 0;
  Hour = 00;
  Min = 00;
begin
  Result := BDate + EncodeTime(Hour, Min, 0 ,0);
end;

function TovOQLGrammar.GetVersion : string;
begin
  Result := '1.0.0.0';
end;

function TovOQLGrammar.GetVersionStr : string;
begin
  Result := '1.0.0.0';
end;

function TovOQLGrammar.GetVersionInfo : string;
begin
  Result := 'Comment: Object Query Launguage Grammar' + #13#10 +
'Author: Kuznetsov Maksim' + #13#10 +
'Copyright: Copyright  2007, All rights reserved.';
end;

procedure TovOQLGrammar.SetVersion(const Value : string);
begin
  // This is a read only property. However, we want the value
  // to appear in the Object Inspector during design time.
end;

procedure TovOQLGrammar.Parse;
begin
  errDist := minErrDist;
GetScanner._Reset;
Get;
_ovOQLGrammar;
end;  {Parse}

procedure TovOQLGrammar.InitSymSet;
begin
symSet[ 0, 0] := [EOFSYMB];
symSet[ 0, 1] := [FROMSym-16, FETCHSym-16, WHERESym-16, HAVINGSym-16, 
                    ORDERSym-16, GROUPSym-16];
symSet[ 0, 2] := [];
symSet[ 0, 3] := [];
symSet[ 0, 4] := [];
symSet[ 1, 0] := [IdentWithLBracketSym, integer_Sym, floatSym, 
                    SQLStringSym];
symSet[ 1, 1] := [];
symSet[ 1, 2] := [NULLSym-32, _colonSym-32];
symSet[ 1, 3] := [];
symSet[ 1, 4] := [];
symSet[ 2, 0] := [IdentWithLBracketSym, integer_Sym, floatSym, 
                    SQLStringSym];
symSet[ 2, 1] := [TIMESTAMPSym-16];
symSet[ 2, 2] := [UPPERSym-32, MONTHSym-32, YEARSym-32, COUNTSym-32, 
                    SUMSym-32, MAXSym-32, MINSym-32, AVGSym-32, NULLSym-32, 
                    _minusSym-32, _colonSym-32, NOTSym-32];
symSet[ 2, 3] := [_lparenSym-48];
symSet[ 2, 4] := [];
symSet[ 3, 0] := [];
symSet[ 3, 1] := [];
symSet[ 3, 2] := [_starSym-32, _minusSym-32];
symSet[ 3, 3] := [_slashSym-48, _plusSym-48, ANDSym-48, ORSym-48];
symSet[ 3, 4] := [];
symSet[ 4, 0] := [IdentWithLBracketSym, integer_Sym, floatSym, 
                    SQLStringSym];
symSet[ 4, 1] := [DISTINCTSym-16, TIMESTAMPSym-16];
symSet[ 4, 2] := [UPPERSym-32, MONTHSym-32, YEARSym-32, COUNTSym-32, 
                    SUMSym-32, MAXSym-32, MINSym-32, AVGSym-32, NULLSym-32, 
                    _minusSym-32, _colonSym-32, NOTSym-32];
symSet[ 4, 3] := [_lparenSym-48];
symSet[ 4, 4] := [];
symSet[ 5, 0] := [EOFSYMB, _semicolonSym, UNIONSym, _equalSym, VALUESSym];
symSet[ 5, 1] := [FROMSym-16, SELECTSym-16, FETCHSym-16, ASSym-16, 
                    WHERESym-16, HAVINGSym-16, ORDERSym-16, GROUPSym-16];
symSet[ 5, 2] := [_starSym-32, _minusSym-32];
symSet[ 5, 3] := [_slashSym-48, _plusSym-48, ANDSym-48, ORSym-48, 
                    _less_greaterSym-48, _lessSym-48, _less_equalSym-48, 
                    _greaterSym-48, _greater_equalSym-48, _commaSym-48];
symSet[ 5, 4] := [_rparenSym-64];
symSet[ 6, 0] := [EOFSYMB, IdentWithLBracketSym, integer_Sym, floatSym, 
                    SQLStringSym];
symSet[ 6, 1] := [FROMSym-16, FETCHSym-16, WHERESym-16, HAVINGSym-16, 
                    ORDERSym-16, GROUPSym-16, _lbrack_star_rbrackSym-16, 
                    TIMESTAMPSym-16];
symSet[ 6, 2] := [UPPERSym-32, MONTHSym-32, YEARSym-32, COUNTSym-32, 
                    SUMSym-32, MAXSym-32, MINSym-32, AVGSym-32, NULLSym-32, 
                    _minusSym-32, _colonSym-32, NOTSym-32];
symSet[ 6, 3] := [_lparenSym-48];
symSet[ 6, 4] := [];
symSet[ 7, 0] := [_equalSym];
symSet[ 7, 1] := [];
symSet[ 7, 2] := [];
symSet[ 7, 3] := [_less_greaterSym-48, _lessSym-48, _less_equalSym-48, 
                    _greaterSym-48, _greater_equalSym-48];
symSet[ 7, 4] := [];
end; {InitSymSet}

end { ovOQLGrammar }.    
