unit ovQueryInfo;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DB, Contnrs, ovTypes, ovModel, ovObjectQuery;

type
  TObjectInfo = class;
  TFieldInfo = class(TObject)
  private
    FName: String;
    FField: TField;
    FFieldName: String;
    FObjectInfo: TObjectInfo;
    FTableName: String;
    FTableAlias: String;
    FFieldIndex: Integer;
    FAutoSelected: Boolean;
  protected
    {{
     ,         
      FieldIndex.   FieldIndex < 0,   
      .
    }
    property FieldIndex: Integer read FFieldIndex;
  public
    constructor Create(AName, AFieldName: String; AutoSelected: Boolean; 
      ATableAlias: String = ''; ATableName: String = '');
    {{
     ,        
    .   Field   nil,  Name  
    Field.FieldName,    Name    
      .
    }
    property Name: String read FName;
    {{
           Query.DataSet.
            ,    nil.
              SELECT , 
            .
    }
    property Field: TField read FField;
    {{
        ,   . 
    ,  ,    .
           Field.FieldName. .
      Name.
    }
    property FieldName: String read FFieldName;
    {{
       ,      . 
    ,  ,     nil.
    }
    property ObjectInfo: TObjectInfo read FObjectInfo;
    {{
       ,      . 
    ,  ,     ''.
    }
    property TableName: String read FTableName;
    {{
       ,   
    SQL-  ,     . 
    ,  ,     ''.
    }
    property TableAlias: String read FTableAlias;
    {{
              SELECT
          SQL- 
    }
    property AutoSelected: Boolean read FAutoSelected;
  end;

  TFieldInfoClass = class of TFieldInfo;

  TObjectInfoList = class;
  TFieldInfoList = class;
  TChildObjectInfo = class;

  TObjectInfo = class(TObject)
  private
    FModelObject: TModelObject;
    FName: String;
    FTableAlias: String;
    FChildren: TObjectInfoList;
    FFields: TFieldInfoList;
    FIsRoot: Boolean;
    FPath: String;
    function GetChildCount: Integer;
    function GetChildren(Index: Integer): TChildObjectInfo;
    function GetFieldCount: Integer;
    function GetFields(Index: Integer): TFieldInfo;
  public
    {{
        .   
       .    
         ,    , 
       .
      ,      I
         Children[I].RelationInfo.ModelRelation
    }
    constructor Create(AName, APath: String; AModelObject: TModelObject; 
      ATableAlias: String);
    destructor Destroy; override;
    function GetField(AFieldName: String; RaiseExceptionOnFail: Boolean = True):
      TFieldInfo; overload;
    function GetObject(AName: String; RaiseExceptionOnFail: Boolean = True): 
      TChildObjectInfo;
    function GetField(AFieldClass: TFieldInfoClass; RaiseExceptionOnFail: Boolean =
      True): TFieldInfo; overload;
    function GetAncestor(AObjectClassName: String): TObjectInfo;
    property ChildCount: Integer read GetChildCount;
    {{
          
    }
    property Children[Index: Integer]: TChildObjectInfo read GetChildren;
    {{
           .
           ,
        .
    }
    property FieldCount: Integer read GetFieldCount;
    {{
         
    }
    property Fields[Index: Integer]: TFieldInfo read GetFields;
    {{
           . 
          ,  
     FROM
    .
    }
    property IsRoot: Boolean read FIsRoot;
    {{
      ,    .
    }
    property ModelObject: TModelObject read FModelObject;
    {{
       ,    FROM 
     .       ,  
         , . ModelObject.Name.
        .

             
     .
    }
    property Name: String read FName;
    {{
       ,   
    SQL-    .
    }
    property TableAlias: String read FTableAlias;
    {{
            .  
          Name.    
           .
    }
    property Path: String read FPath;
  end;

  TChildObjectInfo = class(TObjectInfo)
  private
    FParentObject: TObjectInfo;
    FModelRelation: TModelRelation;
    FRelationTableAlias: String;
    FJoinExpressionItem: TJoinExpressionItem;
  public
    constructor Create(AParentObject: TObjectInfo; AModelRelation: TModelRelation;
      APath, ATableAlias: String);
    {{
         .
    }
    property ParentObject: TObjectInfo read FParentObject;
    {{
        ,  
       TObjectInfo    .
    }
    property ModelRelation: TModelRelation read FModelRelation;
    {{
       ,   
    SQL-  ,   .
           .
    }
    property RelationTableAlias: String read FRelationTableAlias;
    property JoinExpressionItem: TJoinExpressionItem read FJoinExpressionItem write
      FJoinExpressionItem;
  end;

  TObjectInfoList = class(TObjectList)
  private
    function GetObject(AName: String; RaiseExceptionOnFail: Boolean): TObjectInfo;
    function GetObjects(Index: Integer): TObjectInfo;
  public
    constructor Create;
    property Objects[Index: Integer]: TObjectInfo read GetObjects; default;
  end;

  TFieldInfoList = class(TObjectList)
  private
    function GetFields(Index: Integer): TFieldInfo;
    function GetField(AFieldClass: TFieldInfoClass; RaiseExceptionOnFail: Boolean): 
      TFieldInfo;
  public
    property Fields[Index: Integer]: TFieldInfo read GetFields; default;
  end;

  TSelectQueryInfo = class(TObject)
  private
    FObjects: TObjectInfoList;
    FTableCount: Integer;
    FFields: TFieldInfoList;
    FFieldIndexCount: Integer;
    function GetFieldCount: Integer;
    function GetFields(Index: Integer): TFieldInfo;
    function GetObjectCount: Integer;
    function GetObjects(Index: Integer): TObjectInfo;
    function GetNewTableAlias: String;
    function GetNewFieldIndex: Integer;
  public
    {{
     ,   , ..    TFieldInfo, 
       Field   nil.
    }
    function AddObject(AName: String; AModelObject: TModelObject): TObjectInfo;
    function AddChildObject(AParentObject: TObjectInfo; AModelRelation:
      TModelRelation; APath: String): TChildObjectInfo;
    destructor Destroy; override;
    constructor Create; overload;
    function GetObject(AName: String; RaiseExceptionOnFail: Boolean = True): 
      TObjectInfo;
    function GetField(AFieldClass: TFieldInfoClass; RaiseExceptionOnFail: Boolean =
      True): TFieldInfo;
    procedure BindFields(ADataSet: TDataSet);
    function AddField(AParentObject: TObjectInfo; AField: TFieldInfo;
      NeedBindField: Boolean = True): Boolean; overload;
    function AddField(AField: TFieldInfo; NeedBindField: Boolean = True): Boolean;
      overload;
    function GetObject2(APath: String): TObjectInfo;
    function TableIsUsed(TableName: String): Boolean;
    function FindObjectByPath(APath: String): TChildObjectInfo;
    {{
        
    }
    property FieldCount: Integer read GetFieldCount;
    {{
         
    }
    property Fields[Index: Integer]: TFieldInfo read GetFields;
    {{
         .  
         ,    FROM
    .
    }
    property ObjectCount: Integer read GetObjectCount;
    {{
         
    }
    property Objects[Index: Integer]: TObjectInfo read GetObjects;
  end;

  TObjectIdField = class(TFieldInfo)
  end;

  TClassIdField = class(TFieldInfo)
  end;

  TChildIdField = class(TFieldInfo)
  end;

  TExpressionField = class(TFieldInfo)
  end;

  TRelationIdField = class(TFieldInfo)
  public
  end;

  TAttributeField = class(TFieldInfo)
  private
    FModelAttribute: TModelAttribute;
  public
    constructor Create(AName, AFieldName: String; AutoSelected: Boolean;
      AModelAttribute: TModelAttribute);
    property ModelAttribute: TModelAttribute read FModelAttribute;
  end;

  TReferenceField = class(TFieldInfo)
  private
    FModelRelation: TModelRelation;
  public
    constructor Create(AName, AFieldName: String; AutoSelected: Boolean;
      AModelRelation: TModelRelation);
    property ModelRelation: TModelRelation read FModelRelation;
  end;

implementation

{
******************************* TObjectInfoList ********************************
}
constructor TObjectInfoList.Create;
begin
  inherited Create(True);
end;

{{
    .      , 
  nil.
}
function TObjectInfoList.GetObject(AName: String; RaiseExceptionOnFail: 
  Boolean): TObjectInfo;
var
  I: Integer;
begin
  for I := 0 to Count - 1 do
    if Objects[I].Name = AName then
    begin
      Result := Objects[I];
      Exit;
    end;
  if RaiseExceptionOnFail then
    raise Exception.CreateFmt(' "%s"  ', [AName])
  else
    Result := nil
end;

function TObjectInfoList.GetObjects(Index: Integer): TObjectInfo;
begin
  Result := TObjectInfo(inherited Items[Index]);
end;

{
******************************** TFieldInfoList*********************************
}

function TFieldInfoList.GetField(AFieldClass: TFieldInfoClass; 
  RaiseExceptionOnFail: Boolean): TFieldInfo;
var
  I: Integer;
begin
  for I := 0 to Count - 1 do
    if Fields[I] is AFieldClass then
    begin
      Result := Fields[I];
      Exit;
    end;
  if RaiseExceptionOnFail then
    raise Exception.CreateFmt(' "%s"  ', [AFieldClass.ClassName])
  else
    Result := nil
end;

function TFieldInfoList.GetFields(Index: Integer): TFieldInfo;
begin
  Result := TFieldInfo(inherited Items[Index]);
end;

{
********************************* TObjectInfo **********************************
}

{{
    
}
constructor TObjectInfo.Create(AName, APath: String; AModelObject: TModelObject;
  ATableAlias: String);
begin
  inherited Create;
  FName := AName;
  FPath := APath;
  FTableAlias := ATableAlias;
  FModelObject := AModelObject;
  FIsRoot := True;

  FChildren := TObjectInfoList.Create;
  FFields := TFieldInfoList.Create(False);
end;

destructor TObjectInfo.Destroy;
begin
  FFields.Free;
  FChildren.Free;
  inherited;
end;

function TObjectInfo.GetChildCount: Integer;
begin
  Result := FChildren.Count
end;

function TObjectInfo.GetChildren(Index: Integer): TChildObjectInfo;
begin
  Result := TChildObjectInfo(FChildren[Index])
end;

function TObjectInfo.GetFieldCount: Integer;
begin
  Result := FFields.Count
end;

function TObjectInfo.GetFields(Index: Integer): TFieldInfo;
begin
  Result := FFields[Index]
end;

{{
        .
}
function TObjectInfo.GetField(AFieldName: String; RaiseExceptionOnFail: Boolean 
  = True): TFieldInfo;
var
  I: Integer;
begin
  for I := 0 to FieldCount - 1 do
    if UpperCase(Fields[I].FieldName) = UpperCase(AFieldName) then
    begin
      Result := Fields[I];
      Exit;
    end;
  if RaiseExceptionOnFail then
    raise Exception.CreateFmt(' "%s"  ', [AFieldName])
  else
    Result := nil
end;

{{
      .
}
function TObjectInfo.GetObject(AName: String; RaiseExceptionOnFail: Boolean = 
  True): TChildObjectInfo;
begin
  Result := TChildObjectInfo(FChildren.GetObject(AName, RaiseExceptionOnFail));
end;

function TObjectInfo.GetField(AFieldClass: TFieldInfoClass; 
  RaiseExceptionOnFail: Boolean = True): TFieldInfo;
begin
  Result := FFields.GetField(AFieldClass, RaiseExceptionOnFail);
end;

{{
       , 
  ,    AObjectClassName.
}
function TObjectInfo.GetAncestor(AObjectClassName: String): TObjectInfo;
var
  I: Integer;
begin
  for I := 0 to ChildCount - 1 do
  if Children[I].ModelRelation.IsGeneralization and
     (Children[I].ModelObject.FullName = AObjectClassName) then
    begin
      Result := Children[I];
      Exit;
    end;
  raise Exception.Create('   ,   ')
end;

{
****************************** TChildObjectInfo ********************************
}

constructor TChildObjectInfo.Create(AParentObject: TObjectInfo; AModelRelation:
  TModelRelation; APath, ATableAlias: String);
begin
  inherited Create(AModelRelation.Name, APath, AModelRelation.TargetObject, ATableAlias);
  FParentObject := AParentObject;
  FModelRelation := AModelRelation;
  FIsRoot := False;
end;

{
********************************** TFieldInfo **********************************
}

constructor TFieldInfo.Create(AName, AFieldName: String; AutoSelected: Boolean;
  ATableAlias: String = ''; ATableName: String = '');
begin
  inherited Create;
  FFieldIndex := -1;
  FName := AName;
  FFieldName := AFieldName;
  FAutoSelected := AutoSelected;
  FTableName := ATableName;
  FTableAlias := ATableAlias;
end;

{
******************************* TSelectQueryInfo *******************************
}
constructor TSelectQueryInfo.Create;
begin
  inherited Create;
  FObjects := TObjectInfoList.Create;
  FFields := TFieldInfoList.Create(True);
end;

destructor TSelectQueryInfo.Destroy;
begin
  FFields.Free;
  FObjects.Free;
  inherited;
end;

{ ****************************    **************************** }

function TSelectQueryInfo.GetObjectCount: Integer;
begin
  Result := FObjects.Count
end;

function TSelectQueryInfo.GetObjects(Index: Integer): TObjectInfo;
begin
  Result := FObjects[Index]
end;

function TSelectQueryInfo.GetNewTableAlias: String;
begin
  Inc(FTableCount);
  Result := Format('T%d', [FTableCount]);
end;

{{
     .      
,    .
}
function TSelectQueryInfo.AddObject(AName: String; AModelObject: TModelObject):
  TObjectInfo;
var
  AObject: TObjectInfo;
begin
  AObject := FObjects.GetObject(AName, False);
  if AObject <> nil then
    raise Exception.Create('   : ' + AName);

  Result := TObjectInfo.Create(AName, AName, AModelObject, GetNewTableAlias);
  FObjects.Add(Result);
end;

{{
     .      
,    .
}
function TSelectQueryInfo.AddChildObject(AParentObject: TObjectInfo;
  AModelRelation: TModelRelation; APath: String): TChildObjectInfo;
var
  AObject: TObjectInfo;
begin
  AObject := AParentObject.FChildren.GetObject(AModelRelation.Name, False);
  if AObject <> nil then
    raise Exception.Create('   : ' + AModelRelation.Name);

  Result := TChildObjectInfo.Create(AParentObject, AModelRelation, APath, GetNewTableAlias);
  AParentObject.FChildren.Add(Result);
end;

{{
     .
}
function TSelectQueryInfo.GetObject(AName: String; RaiseExceptionOnFail:
  Boolean = True): TObjectInfo;
begin
  Result := FObjects.GetObject(AName, RaiseExceptionOnFail);
end;

{{
     .
}
function TSelectQueryInfo.GetObject2(APath: String): TObjectInfo;

  function FindInChildren(ParentObjectInfo: TObjectInfo; var FoundObjectInfo: TObjectInfo): Boolean;
  var
    I: Integer;
  begin
    with ParentObjectInfo do
      for I := 0 to ChildCount - 1 do
        if Children[I].Path = APath
        then begin
          Result := True;
          FoundObjectInfo := Children[I];
          Exit;
        end else
        if FindInChildren(Children[I], FoundObjectInfo)
        then begin
          Result := True;
          Exit;
        end;
      Result := False;
  end;

var
  I: Integer;
begin
  for I := 0 to ObjectCount - 1 do
    if Objects[I].Path = APath
    then begin
      Result := Objects[I];
      Exit;
    end else
      if FindInChildren(Objects[I], Result) then Exit;

  raise Exception.Create('  :'+APath);
end;

function TSelectQueryInfo.FindObjectByPath(APath: String): TChildObjectInfo;

  function FindInChildren(ParentObjectInfo: TObjectInfo; var FoundObjectInfo: TChildObjectInfo): Boolean;
  var
    I: Integer;
  begin
    with ParentObjectInfo do
      for I := 0 to ChildCount - 1 do
        if Children[I].Path = APath
        then begin
          Result := True;
          FoundObjectInfo := Children[I];
          Exit;
        end else
        if FindInChildren(Children[I], FoundObjectInfo)
        then begin
          Result := True;
          Exit;
        end;
      Result := False;
  end;

var
  I: Integer;
begin
  for I := 0 to ObjectCount - 1 do
    if FindInChildren(Objects[I], Result) then Exit;
  Result := nil
end;

{{
          True  
.     True  ,   
   TableName.
}
function TSelectQueryInfo.TableIsUsed(TableName: String): Boolean;

  function FindTableInChildren(AObjectInfo: TObjectInfo): Boolean;
  var
    I: Integer;
  begin
    with AObjectInfo do
      for I := 0 to ChildCount - 1 do
        if ((Children[I].ModelObject.TableName = TableName) or
           Children[I].ModelRelation.IsAssociation and
           (Children[I].ModelRelation.TableName = TableName)) or
           FindTableInChildren(Children[I])
        then begin
          Result := True;
          Exit;
        end;
      Result := False;
  end;

var
  I: Integer;
begin
  for I := 0 to ObjectCount - 1 do
    if (Objects[I].ModelObject.TableName = TableName) or
       FindTableInChildren(Objects[I])
    then begin
      Result := True;
      Exit;
    end;
  Result := False;
end;

{ ****************************    ******************************* }

function TSelectQueryInfo.GetFieldCount: Integer;
begin
  Result := FFields.Count
end;

function TSelectQueryInfo.GetFields(Index: Integer): TFieldInfo;
begin
  Result := FFields[Index]
end;

function TSelectQueryInfo.GetField(AFieldClass: TFieldInfoClass; 
  RaiseExceptionOnFail: Boolean = True): TFieldInfo;
begin
  Result := FFields.GetField(AFieldClass, RaiseExceptionOnFail);
end;

{{
   
}
function TSelectQueryInfo.GetNewFieldIndex: Integer;
begin
  Result := FFieldIndexCount;
  Inc(FFieldIndexCount);
end;

{{
       .
}
function TSelectQueryInfo.AddField(AParentObject: TObjectInfo; AField:
  TFieldInfo; NeedBindField: Boolean = True): Boolean;
begin
  //     ,       
  //     ,   
  AField.FTableName := AParentObject.ModelObject.TableName;
  AField.FTableAlias := AParentObject.TableAlias;

  Result := AddField(AField, NeedBindField);
  AParentObject.FFields.Add(AField);
  AField.FObjectInfo := AParentObject;
end;

{{
          .
    True,        
 .
    False,   AField    
 ,        , .. 
AField            
 .
}
function TSelectQueryInfo.AddField(AField: TFieldInfo; NeedBindField: Boolean =
  True): Boolean;
var
  I: Integer;
  SameField: TFieldInfo;
begin
  Result := False;

  if NeedBindField then
  begin
    //           
    SameField := nil;
    for I := 0 to FFields.Count - 1 do
      if (Fields[I].FFieldIndex >= 0) and //   ,     SQL-
         (Fields[I].TableAlias = AField.TableAlias) and
         (Fields[I].FieldName = AField.FieldName)
      then
      begin
        SameField := Fields[I];
        Break;
      end;

    if SameField = nil then begin
      AField.FFieldIndex := GetNewFieldIndex;
      Result := True;
    end else
      AField.FFieldIndex := SameField.FieldIndex;
  end;

  FFields.Add(AField);
end;

{{
           ADataSet
    ,    FieldIndex  .
}
procedure TSelectQueryInfo.BindFields(ADataSet: TDataSet);
var
  I: Integer;
begin
  for I := 0 to FieldCount - 1 do
    with Fields[I] do
      if FieldIndex >= 0 then FField := ADataSet.Fields[FieldIndex]
end;

{
****************************** TAttributeField *********************************
}

constructor TAttributeField.Create(AName, AFieldName: String; AutoSelected:
  Boolean; AModelAttribute: TModelAttribute);
begin
  inherited Create(AName, AFieldName, AutoSelected);
  FModelAttribute := AModelAttribute;
end;

{
****************************** TReferenceField *********************************
}

constructor TReferenceField.Create(AName, AFieldName: String; AutoSelected:
  Boolean; AModelRelation: TModelRelation);
begin
  inherited Create(AName, AFieldName, AutoSelected);
  FModelRelation := AModelRelation;
end;

end.
