unit ovRestoreDatabaseDlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ovDBBackup, ComCtrls, Contnrs;

type
  TfmDatabaseRestoreDialog = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    mmBackupDescription: TMemo;
    OkButton: TButton;
    CancelButton: TButton;
    BackupListView: TListView;
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BackupListViewDblClick(Sender: TObject);
    procedure BackupListViewSelectItem(Sender: TObject; Item: TListItem; Selected:
      Boolean);
  private
    { Private declarations }
    FBackupList: TObjectList;
    procedure FillBackupList(DatabaseBackupComponent: TovModelDatabaseBackup;
      ConnectionName: String);
  public
    { Public declarations }
  end;

function ShowDatabaseRestoreDlg(DatabaseBackupComponent:
  TovModelDatabaseBackup; ConnectionName: String; var BackupName: String):
  Boolean;

implementation

{$R *.dfm}

function ShowDatabaseRestoreDlg(DatabaseBackupComponent:
  TovModelDatabaseBackup; ConnectionName: String; var BackupName: String):
  Boolean;
begin
  with TfmDatabaseRestoreDialog.Create(Application) do
  try
    FillBackupList(DatabaseBackupComponent, ConnectionName);
    Result := ShowModal = mrOk;
    if Result then
      BackupName := BackupListView.Selected.Caption;
  finally
    Free
  end;
end;

{ TfmDatabaseRestoreDialog }

procedure TfmDatabaseRestoreDialog.FormCreate(Sender: TObject);
begin
  FBackupList := TObjectList.Create;
end;

procedure TfmDatabaseRestoreDialog.FormDestroy(Sender: TObject);
begin
  FBackupList.Free;
end;

procedure TfmDatabaseRestoreDialog.BackupListViewDblClick(Sender: TObject);
begin
  if BackupListView.Selected <> nil then ModalResult := mrOk
end;

procedure TfmDatabaseRestoreDialog.BackupListViewSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  mmBackupDescription.Text := TovDatabaseBackupInfo(Item.Data).BackupDescription;
  OkButton.Enabled := True;
end;

procedure TfmDatabaseRestoreDialog.FillBackupList(DatabaseBackupComponent:
  TovModelDatabaseBackup; ConnectionName: String);
var
  I: Integer;
begin
  DatabaseBackupComponent.GetBackupList(ConnectionName, FBackupList);
  with BackupListView do
  begin
    Items.Clear;
    for I := 0 to FBackupList.Count - 1 do
      with Items.Add, TovDatabaseBackupInfo(FBackupList[I]) do
      begin
        Caption := BackupName;
        SubItems.Add(DateTimeToStr(BackupDate));
        Data := FBackupList[I];
      end
  end;
end;

end.
