unit ovNewRelation;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ovModel, AppEvnts;

type
  TfrmNewRelation = class(TForm)
    OkBtn: TButton;
    Button2: TButton;
    rgRelationType: TRadioGroup;
    cbTargetObject: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    edName: TEdit;
    ApplicationEvents: TApplicationEvents;
    procedure FormShow(Sender: TObject);
    procedure rgRelationTypeClick(Sender: TObject);
    procedure ApplicationEventsIdle(Sender: TObject; var Done: Boolean);
    procedure cbTargetObjectCloseUp(Sender: TObject);
  private
    { Private declarations }
    FModel: TDomainModel;
    FSourceObject: TModelObject;
    function IsGeneralizationSelected: Boolean;
  public
    { Public declarations }
  end;

function AddRelation(AModel: TDomainModel; AObject: TModelObject; 
  DefaulRelationType: TRelationType): TModelRelation;

var
  frmNewRelation: TfrmNewRelation;

implementation

{$R *.dfm}

function AddRelation(AModel: TDomainModel; AObject: TModelObject;
  DefaulRelationType: TRelationType): TModelRelation;
begin
  with TfrmNewRelation.Create(Application) do
  try
    FModel := AModel;
    FSourceObject := AObject;
    rgRelationType.ItemIndex := Integer(DefaulRelationType);
    rgRelationTypeClick(nil);
    if ShowModal = mrOk then
      if Not IsGeneralizationSelected then
        Result := FSourceObject.AddRelation(edName.Text, cbTargetObject.Text,
          TRelationType(rgRelationType.ItemIndex))
      else
        Result := FSourceObject.AddGeneralization(cbTargetObject.Text)
    else
      Result := nil
  finally
    Free
  end;
end;

procedure TfrmNewRelation.FormShow(Sender: TObject);
var
  I: Integer;
begin
  cbTargetObject.Items.Clear;
  with FModel do
    for I := 0 to ObjectCount - 1 do
      cbTargetObject.Items.Add(Objects[I].FullName);
end;

procedure TfrmNewRelation.rgRelationTypeClick(Sender: TObject);
begin
  edName.Enabled := Not IsGeneralizationSelected
end;

procedure TfrmNewRelation.ApplicationEventsIdle(Sender: TObject;
  var Done: Boolean);
begin
  OkBtn.Enabled := (cbTargetObject.Text <> '') and
    (IsGeneralizationSelected or (edName.Text <> ''))
end;

procedure TfrmNewRelation.cbTargetObjectCloseUp(Sender: TObject);
begin
  if cbTargetObject.Text <> '' then
    edName.Text := ExtractObjectName(cbTargetObject.Text)
end;

function TfrmNewRelation.IsGeneralizationSelected: Boolean;
begin
  Result := rgRelationType.ItemIndex = rgRelationType.Items.Count - 1;
end;

end.
