unit ovObjectInspectorDlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ImgList, ComCtrls,
  ovObjectInspector, ovIObjects;

type
  TfmObjectInspector = class(TForm)
    Inspector: TovObjectInspector;
    Panel: TPanel;
    ImageList: TImageList;
    DeleteBtn: TBitBtn;
    procedure DeleteBtnClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    FObject: IovObject;
    { Private declarations }
  public
    { Public declarations }
  end;

procedure ShowObjectInspector(AObject: IovObject; AllowDelete: Boolean = False);

implementation

{$R *.dfm}

procedure ShowObjectInspector(AObject: IovObject; AllowDelete: Boolean = False);
begin
  with TfmObjectInspector.Create(Application) do
  try
    FObject := AObject;
    Panel.Visible := AllowDelete;
    Inspector.ShowObject(AObject);
    ShowModal;
  finally
    Free
  end;
end;

{ TfmObjectInspector }

procedure TfmObjectInspector.DeleteBtnClick(Sender: TObject);
begin
  if Application.MessageBox('  ?', '',
    MB_ICONQUESTION or MB_YESNO) = idYes
  then
  begin
    FObject.Delete;
    Close;
  end;
end;

procedure TfmObjectInspector.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #27 then Close
end;

end.
